#include "ffi-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 6 "../../../../Macaulay2/d/ffi.d"
#include <dlfcn.h>
	#include <ffi.h>
	/* FFI_BAD_ARGTYPE not introduced until libffi 3.4 in 2021 */
	#ifndef FFI_BAD_ARGTYPE
	  #define FFI_BAD_ARGTYPE 3
	#endif
	#include <M2mem.h>
# line 16 "../../../../Macaulay2/d/ffi.d"

#ifndef HAVE_FFI_GET_STRUCT_OFFSETS
#define FFI_ALIGN(v, a)  (((((size_t) (v))-1) | ((a)-1))+1)

ffi_status
ffi_get_struct_offsets(ffi_abi abi, ffi_type *struct_type, size_t *offsets)
{
  ffi_cif cif;
  ffi_status status;
  ffi_type **ptr;
  size_t size;

  status = ffi_prep_cif(&cif, abi, 0, struct_type, NULL);
  if (status != FFI_OK)
    return status;

  ptr = &(struct_type->elements[0]);
  size = 0;

  while ((*ptr) != NULL) {
      size = FFI_ALIGN(size, (*ptr)->alignment);
      *offsets++ = size;
      size += (*ptr)->size;
      ptr++;
  }

  return FFI_OK;
}
#endif

# line 48 "../../../../Macaulay2/d/ffi.d"
static parse_Expr toExpr_3(void * x){
  # line 48 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell tmp_;
  # line 48 "../../../../Macaulay2/d/ffi.d"
  tmp_ = (parse_pointerCell) GC_MALLOC(sizeof(struct parse_pointerCell_struct));
  if (0 == tmp_) outofmem2((size_t)sizeof(struct parse_pointerCell_struct));
  # line 48 "../../../../Macaulay2/d/ffi.d"
  tmp_->type_ = 81;
  # line 48 "../../../../Macaulay2/d/ffi.d"
  tmp_->v = x;
  # line 48 "../../../../Macaulay2/d/ffi.d"
  return ((parse_Expr)tmp_);
  # line 48 "../../../../Macaulay2/d/ffi.d"
  }
# line 48 "../../../../Macaulay2/d/ffi.d"
static M2_string str_;
# line 49 "../../../../Macaulay2/d/ffi.d"
static parse_Expr WrongArgPointer(){
  # line 49 "../../../../Macaulay2/d/ffi.d"
  return expr_WrongArg(str_);
  # line 49 "../../../../Macaulay2/d/ffi.d"
  }
# line 49 "../../../../Macaulay2/d/ffi.d"
static M2_string str__1;
# line 50 "../../../../Macaulay2/d/ffi.d"
static parse_Expr WrongArgPointer_1(int n){
  # line 50 "../../../../Macaulay2/d/ffi.d"
  return expr_WrongArg_1(n, str__1);
  # line 50 "../../../../Macaulay2/d/ffi.d"
  }
# line 50 "../../../../Macaulay2/d/ffi.d"
static M2_string str__2;
# line 53 "../../../../Macaulay2/d/ffi.d"
static void * getMem(int n){
  # line 53 "../../../../Macaulay2/d/ffi.d"
  return getmem(n);
  # line 53 "../../../../Macaulay2/d/ffi.d"
  }
# line 54 "../../../../Macaulay2/d/ffi.d"
static void * getMemAtomic(int n){
  # line 54 "../../../../Macaulay2/d/ffi.d"
  return getmem_atomic(n);
  # line 54 "../../../../Macaulay2/d/ffi.d"
  }
# line 54 "../../../../Macaulay2/d/ffi.d"
static int pointerSize;
# line 57 "../../../../Macaulay2/d/ffi.d"
static parse_Expr dlerror0(){
  # line 57 "../../../../Macaulay2/d/ffi.d"
  return expr_buildErrorPacket(M2_tostring_2(dlerror()));
  # line 57 "../../../../Macaulay2/d/ffi.d"
  }
# line 60 "../../../../Macaulay2/d/ffi.d"
static parse_Expr dlopen0(parse_Expr e){
  # line 60 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell s;
  # line 60 "../../../../Macaulay2/d/ffi.d"
  voidPointerOrNull r;
  # line 60 "../../../../Macaulay2/d/ffi.d"
  void * handle;
  # line 60 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__1;
  # line 60 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__2;
  # line 60 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 60 "../../../../Macaulay2/d/ffi.d"
    case 19:;
    # line 60 "../../../../Macaulay2/d/ffi.d"
    s = ((M2_stringCell)e);
    # line 62 "../../../../Macaulay2/d/ffi.d"
    r = dlopen(M2_tocharstar(s->v), RTLD_LAZY);
    # line 64 "../../../../Macaulay2/d/ffi.d"
    if (0 == r) goto L1_;
    # line 64 "../../../../Macaulay2/d/ffi.d"
    goto L0_;
    # line 64 "../../../../Macaulay2/d/ffi.d"
    L1_:;
    # line 65 "../../../../Macaulay2/d/ffi.d"
    tmp__1 = dlerror0();
    # line 65 "../../../../Macaulay2/d/ffi.d"
    goto L2_;
    # line 65 "../../../../Macaulay2/d/ffi.d"
    L0_:;
    # line 64 "../../../../Macaulay2/d/ffi.d"
    handle = ((void *)r);
    # line 66 "../../../../Macaulay2/d/ffi.d"
    tmp__1 = toExpr_3(handle);
    # line 66 "../../../../Macaulay2/d/ffi.d"
    goto L2_;
    # line 66 "../../../../Macaulay2/d/ffi.d"
    L2_:;
    # line 66 "../../../../Macaulay2/d/ffi.d"
    tmp__2 = tmp__1;
    # line 66 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 66 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 67 "../../../../Macaulay2/d/ffi.d"
    tmp__2 = expr_WrongArgString();
    # line 67 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 67 "../../../../Macaulay2/d/ffi.d"
    };
  # line 67 "../../../../Macaulay2/d/ffi.d"
  return tmp__2;
  # line 67 "../../../../Macaulay2/d/ffi.d"
  }
# line 67 "../../../../Macaulay2/d/ffi.d"
static M2_string str__3;
# line 67 "../../../../Macaulay2/d/ffi.d"
static M2_string str__4;
# line 71 "../../../../Macaulay2/d/ffi.d"
static parse_Expr dlsym0(parse_Expr e){
  # line 71 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell y;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  voidPointerOrNull r_1;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  void * addr;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_1;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell y_1;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  voidPointerOrNull r_2;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  void * addr_1;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__3;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__4;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__5;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__6;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__7;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__8;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__9;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__10;
  # line 71 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 71 "../../../../Macaulay2/d/ffi.d"
    case 19:;
    # line 71 "../../../../Macaulay2/d/ffi.d"
    y = ((M2_stringCell)e);
    # line 73 "../../../../Macaulay2/d/ffi.d"
    r_1 = dlsym(RTLD_DEFAULT, M2_tocharstar(y->v));
    # line 75 "../../../../Macaulay2/d/ffi.d"
    if (0 == r_1) goto L4_;
    # line 75 "../../../../Macaulay2/d/ffi.d"
    goto L3_;
    # line 75 "../../../../Macaulay2/d/ffi.d"
    L4_:;
    # line 76 "../../../../Macaulay2/d/ffi.d"
    tmp__3 = dlerror0();
    # line 76 "../../../../Macaulay2/d/ffi.d"
    goto L5_;
    # line 76 "../../../../Macaulay2/d/ffi.d"
    L3_:;
    # line 75 "../../../../Macaulay2/d/ffi.d"
    addr = ((void *)r_1);
    # line 77 "../../../../Macaulay2/d/ffi.d"
    tmp__3 = toExpr_3(addr);
    # line 77 "../../../../Macaulay2/d/ffi.d"
    goto L5_;
    # line 77 "../../../../Macaulay2/d/ffi.d"
    L5_:;
    # line 77 "../../../../Macaulay2/d/ffi.d"
    tmp__4 = tmp__3;
    # line 77 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 77 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 71 "../../../../Macaulay2/d/ffi.d"
    a = ((parse_Sequence)e);
    # line 79 "../../../../Macaulay2/d/ffi.d"
    if ((a->len != 2)) goto L6_;
    # line 80 "../../../../Macaulay2/d/ffi.d"
    tmp__5 = a->array[0];
    # line 80 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__5->type_) {;
      # line 80 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 80 "../../../../Macaulay2/d/ffi.d"
      x_1 = ((parse_pointerCell)tmp__5);
      # line 81 "../../../../Macaulay2/d/ffi.d"
      tmp__6 = a->array[1];
      # line 81 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__6->type_) {;
	# line 81 "../../../../Macaulay2/d/ffi.d"
	case 19:;
	# line 81 "../../../../Macaulay2/d/ffi.d"
	y_1 = ((M2_stringCell)tmp__6);
	# line 83 "../../../../Macaulay2/d/ffi.d"
	r_2 = dlsym(x_1->v, M2_tocharstar(y_1->v));
	# line 85 "../../../../Macaulay2/d/ffi.d"
	if (0 == r_2) goto L8_;
	# line 85 "../../../../Macaulay2/d/ffi.d"
	goto L7_;
	# line 85 "../../../../Macaulay2/d/ffi.d"
	L8_:;
	# line 86 "../../../../Macaulay2/d/ffi.d"
	tmp__7 = dlerror0();
	# line 86 "../../../../Macaulay2/d/ffi.d"
	goto L9_;
	# line 86 "../../../../Macaulay2/d/ffi.d"
	L7_:;
	# line 85 "../../../../Macaulay2/d/ffi.d"
	addr_1 = ((void *)r_2);
	# line 87 "../../../../Macaulay2/d/ffi.d"
	tmp__7 = toExpr_3(addr_1);
	# line 87 "../../../../Macaulay2/d/ffi.d"
	goto L9_;
	# line 87 "../../../../Macaulay2/d/ffi.d"
	L9_:;
	# line 87 "../../../../Macaulay2/d/ffi.d"
	tmp__8 = tmp__7;
	# line 87 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 87 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 88 "../../../../Macaulay2/d/ffi.d"
	tmp__8 = expr_WrongArgString_1(2);
	# line 88 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 88 "../../../../Macaulay2/d/ffi.d"
	};
      # line 88 "../../../../Macaulay2/d/ffi.d"
      tmp__9 = tmp__8;
      # line 88 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 88 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 89 "../../../../Macaulay2/d/ffi.d"
      tmp__9 = WrongArgPointer_1(1);
      # line 89 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 89 "../../../../Macaulay2/d/ffi.d"
      };
    # line 89 "../../../../Macaulay2/d/ffi.d"
    tmp__10 = tmp__9;
    # line 89 "../../../../Macaulay2/d/ffi.d"
    goto L10_;
    # line 89 "../../../../Macaulay2/d/ffi.d"
    L6_:;
    # line 79 "../../../../Macaulay2/d/ffi.d"
    tmp__10 = expr_WrongNumArgs_3(1, 2);
    # line 79 "../../../../Macaulay2/d/ffi.d"
    L10_:;
    # line 79 "../../../../Macaulay2/d/ffi.d"
    tmp__4 = tmp__10;
    # line 79 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 79 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 90 "../../../../Macaulay2/d/ffi.d"
    tmp__4 = expr_WrongArg(str__4);
    # line 90 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 90 "../../../../Macaulay2/d/ffi.d"
    };
  # line 90 "../../../../Macaulay2/d/ffi.d"
  return tmp__4;
  # line 90 "../../../../Macaulay2/d/ffi.d"
  }
# line 90 "../../../../Macaulay2/d/ffi.d"
static M2_string str__5;
# line 90 "../../../../Macaulay2/d/ffi.d"
static void * ffiTypeVoid;
# line 90 "../../../../Macaulay2/d/ffi.d"
static int ffiOk;
# line 97 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiTypeSize(parse_Expr e){
  # line 97 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_2;
  # line 97 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__11;
  # line 97 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 97 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 97 "../../../../Macaulay2/d/ffi.d"
    x_2 = ((parse_pointerCell)e);
    # line 98 "../../../../Macaulay2/d/ffi.d"
    tmp__11 = util_toExpr(((ffi_type *)x_2->v)->size);
    # line 98 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 98 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 99 "../../../../Macaulay2/d/ffi.d"
    tmp__11 = WrongArgPointer();
    # line 99 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 99 "../../../../Macaulay2/d/ffi.d"
    };
  # line 99 "../../../../Macaulay2/d/ffi.d"
  return tmp__11;
  # line 99 "../../../../Macaulay2/d/ffi.d"
  }
# line 99 "../../../../Macaulay2/d/ffi.d"
static M2_string str__6;
# line 99 "../../../../Macaulay2/d/ffi.d"
static M2_string str__7;
# line 99 "../../../../Macaulay2/d/ffi.d"
static M2_string str__8;
# line 99 "../../../../Macaulay2/d/ffi.d"
static M2_string str__9;
# line 99 "../../../../Macaulay2/d/ffi.d"
static M2_string str__10;
# line 103 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiError(int r){
  # line 103 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__12;
  # line 103 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__13;
  # line 103 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__14;
  # line 103 "../../../../Macaulay2/d/ffi.d"
  if ((r == FFI_BAD_TYPEDEF)) goto L11_;
  # line 105 "../../../../Macaulay2/d/ffi.d"
  if ((r == FFI_BAD_ABI)) goto L12_;
  # line 107 "../../../../Macaulay2/d/ffi.d"
  if ((r == FFI_BAD_ARGTYPE)) goto L13_;
  # line 109 "../../../../Macaulay2/d/ffi.d"
  tmp__12 = expr_buildErrorPacket(str__7);
  # line 109 "../../../../Macaulay2/d/ffi.d"
  goto L14_;
  # line 109 "../../../../Macaulay2/d/ffi.d"
  L13_:;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  tmp__12 = expr_buildErrorPacket(str__8);
  # line 108 "../../../../Macaulay2/d/ffi.d"
  L14_:;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  tmp__13 = tmp__12;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  goto L15_;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  L12_:;
  # line 106 "../../../../Macaulay2/d/ffi.d"
  tmp__13 = expr_buildErrorPacket(str__9);
  # line 106 "../../../../Macaulay2/d/ffi.d"
  L15_:;
  # line 106 "../../../../Macaulay2/d/ffi.d"
  tmp__14 = tmp__13;
  # line 106 "../../../../Macaulay2/d/ffi.d"
  goto L16_;
  # line 106 "../../../../Macaulay2/d/ffi.d"
  L11_:;
  # line 104 "../../../../Macaulay2/d/ffi.d"
  tmp__14 = expr_buildErrorPacket(str__10);
  # line 104 "../../../../Macaulay2/d/ffi.d"
  L16_:;
  # line 104 "../../../../Macaulay2/d/ffi.d"
  return tmp__14;
  # line 104 "../../../../Macaulay2/d/ffi.d"
  }
# line 104 "../../../../Macaulay2/d/ffi.d"
static M2_string str__11;
# line 112 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPrepCif(parse_Expr e){
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_1;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_3;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_List y_2;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  int i;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell z;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * argtypes;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  void * cif;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  int r_3;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__15;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__16;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__17;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  int tmp__18;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__19;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  void * tmp__20;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__21;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__22;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__23;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__24;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__25;
  # line 112 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 112 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 112 "../../../../Macaulay2/d/ffi.d"
    a_1 = ((parse_Sequence)e);
    # line 114 "../../../../Macaulay2/d/ffi.d"
    if ((a_1->len != 2)) goto L17_;
    # line 115 "../../../../Macaulay2/d/ffi.d"
    tmp__15 = a_1->array[0];
    # line 115 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__15->type_) {;
      # line 115 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 115 "../../../../Macaulay2/d/ffi.d"
      x_3 = ((parse_pointerCell)tmp__15);
      # line 116 "../../../../Macaulay2/d/ffi.d"
      tmp__16 = a_1->array[1];
      # line 116 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__16->type_) {;
	# line 116 "../../../../Macaulay2/d/ffi.d"
	case 46:;
	# line 116 "../../../../Macaulay2/d/ffi.d"
	y_2 = ((parse_List)tmp__16);
	# line 116 "../../../../Macaulay2/d/ffi.d"
	i = 0;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	tmp__18 = y_2->v->len;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	tmp__17 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__18)*sizeof(void *)-sizeof(void *));
	if (0 == tmp__17) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__18)*sizeof(void *)-sizeof(void *));
	# line 118 "../../../../Macaulay2/d/ffi.d"
	tmp__17->len = tmp__18;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	if ((tmp__18 == 0)) goto L19_;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	L18_:;
	# line 119 "../../../../Macaulay2/d/ffi.d"
	tmp__19 = y_2->v->array[i];
	# line 119 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__19->type_) {;
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  case 81:;
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  z = ((parse_pointerCell)tmp__19);
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  tmp__20 = z->v;
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 119 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 120 "../../../../Macaulay2/d/ffi.d"
	  tmp__20 = ffiTypeVoid;
	  # line 120 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 120 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 120 "../../../../Macaulay2/d/ffi.d"
	tmp__17->array[i] = tmp__20;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	if (((++ i) < tmp__18)) goto L20_;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	goto L19_;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	L20_:;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	goto L18_;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	L19_:;
	# line 118 "../../../../Macaulay2/d/ffi.d"
	argtypes = tmp__17;
	# line 121 "../../../../Macaulay2/d/ffi.d"
	cif = getmem(sizeof(ffi_cif));
	# line 122 "../../../../Macaulay2/d/ffi.d"
	r_3 = ffi_prep_cif((ffi_cif *)cif, FFI_DEFAULT_ABI, argtypes->len, (ffi_type *) x_3->v, (ffi_type **) argtypes->array);
	# line 127 "../../../../Macaulay2/d/ffi.d"
	if ((r_3 != ffiOk)) goto L21_;
	# line 128 "../../../../Macaulay2/d/ffi.d"
	tmp__21 = toExpr_3(cif);
	# line 128 "../../../../Macaulay2/d/ffi.d"
	goto L22_;
	# line 128 "../../../../Macaulay2/d/ffi.d"
	L21_:;
	# line 127 "../../../../Macaulay2/d/ffi.d"
	tmp__21 = ffiError(r_3);
	# line 127 "../../../../Macaulay2/d/ffi.d"
	L22_:;
	# line 127 "../../../../Macaulay2/d/ffi.d"
	tmp__22 = tmp__21;
	# line 127 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 127 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 129 "../../../../Macaulay2/d/ffi.d"
	tmp__22 = expr_WrongArg_1(2, str__11);
	# line 129 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 129 "../../../../Macaulay2/d/ffi.d"
	};
      # line 129 "../../../../Macaulay2/d/ffi.d"
      tmp__23 = tmp__22;
      # line 129 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 129 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 130 "../../../../Macaulay2/d/ffi.d"
      tmp__23 = WrongArgPointer_1(1);
      # line 130 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 130 "../../../../Macaulay2/d/ffi.d"
      };
    # line 130 "../../../../Macaulay2/d/ffi.d"
    tmp__24 = tmp__23;
    # line 130 "../../../../Macaulay2/d/ffi.d"
    goto L23_;
    # line 130 "../../../../Macaulay2/d/ffi.d"
    L17_:;
    # line 114 "../../../../Macaulay2/d/ffi.d"
    tmp__24 = expr_WrongNumArgs_1(2);
    # line 114 "../../../../Macaulay2/d/ffi.d"
    L23_:;
    # line 114 "../../../../Macaulay2/d/ffi.d"
    tmp__25 = tmp__24;
    # line 114 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 114 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 131 "../../../../Macaulay2/d/ffi.d"
    tmp__25 = expr_WrongNumArgs_1(2);
    # line 131 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 131 "../../../../Macaulay2/d/ffi.d"
    };
  # line 131 "../../../../Macaulay2/d/ffi.d"
  return tmp__25;
  # line 131 "../../../../Macaulay2/d/ffi.d"
  }
# line 131 "../../../../Macaulay2/d/ffi.d"
static M2_string str__12;
# line 131 "../../../../Macaulay2/d/ffi.d"
static M2_string str__13;
# line 135 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPrepCifVar(parse_Expr e){
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_2;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_1;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_4;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_List y_3;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  int i_1;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell z_1;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * argtypes_1;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  void * cif_1;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  int r_4;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__26;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__27;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__28;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__29;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  int tmp__30;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__31;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  void * tmp__32;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__33;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__34;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__35;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__36;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__37;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__38;
  # line 135 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 135 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 135 "../../../../Macaulay2/d/ffi.d"
    a_2 = ((parse_Sequence)e);
    # line 137 "../../../../Macaulay2/d/ffi.d"
    if ((a_2->len != 3)) goto L24_;
    # line 138 "../../../../Macaulay2/d/ffi.d"
    tmp__26 = a_2->array[0];
    # line 138 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__26->type_) {;
      # line 138 "../../../../Macaulay2/d/ffi.d"
      case 3:;
      # line 138 "../../../../Macaulay2/d/ffi.d"
      n_1 = ((gmp_ZZcell)tmp__26);
      # line 139 "../../../../Macaulay2/d/ffi.d"
      tmp__27 = a_2->array[1];
      # line 139 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__27->type_) {;
	# line 139 "../../../../Macaulay2/d/ffi.d"
	case 81:;
	# line 139 "../../../../Macaulay2/d/ffi.d"
	x_4 = ((parse_pointerCell)tmp__27);
	# line 140 "../../../../Macaulay2/d/ffi.d"
	tmp__28 = a_2->array[2];
	# line 140 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__28->type_) {;
	  # line 140 "../../../../Macaulay2/d/ffi.d"
	  case 46:;
	  # line 140 "../../../../Macaulay2/d/ffi.d"
	  y_3 = ((parse_List)tmp__28);
	  # line 140 "../../../../Macaulay2/d/ffi.d"
	  i_1 = 0;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  tmp__30 = y_3->v->len;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  ;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  tmp__29 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__30)*sizeof(void *)-sizeof(void *));
	  if (0 == tmp__29) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__30)*sizeof(void *)-sizeof(void *));
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  tmp__29->len = tmp__30;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  if ((tmp__30 == 0)) goto L26_;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  L25_:;
	  # line 143 "../../../../Macaulay2/d/ffi.d"
	  tmp__31 = y_3->v->array[i_1];
	  # line 143 "../../../../Macaulay2/d/ffi.d"
	  switch (tmp__31->type_) {;
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    case 81:;
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    z_1 = ((parse_pointerCell)tmp__31);
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    tmp__32 = z_1->v;
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 143 "../../../../Macaulay2/d/ffi.d"
	    default:;
	    # line 144 "../../../../Macaulay2/d/ffi.d"
	    tmp__32 = ffiTypeVoid;
	    # line 144 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 144 "../../../../Macaulay2/d/ffi.d"
	    };
	  # line 144 "../../../../Macaulay2/d/ffi.d"
	  tmp__29->array[i_1] = tmp__32;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  if (((++ i_1) < tmp__30)) goto L27_;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  goto L26_;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  L27_:;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  goto L25_;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  L26_:;
	  # line 142 "../../../../Macaulay2/d/ffi.d"
	  argtypes_1 = tmp__29;
	  # line 145 "../../../../Macaulay2/d/ffi.d"
	  cif_1 = getmem(sizeof(ffi_cif));
	  # line 146 "../../../../Macaulay2/d/ffi.d"
	  r_4 = ffi_prep_cif_var((ffi_cif *)cif_1, FFI_DEFAULT_ABI, gmp_toInt_1(n_1), argtypes_1->len, (ffi_type *) x_4->v, (ffi_type **) argtypes_1->array);
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  if ((r_4 != ffiOk)) goto L28_;
	  # line 153 "../../../../Macaulay2/d/ffi.d"
	  tmp__33 = toExpr_3(cif_1);
	  # line 153 "../../../../Macaulay2/d/ffi.d"
	  goto L29_;
	  # line 153 "../../../../Macaulay2/d/ffi.d"
	  L28_:;
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  tmp__33 = ffiError(r_4);
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  L29_:;
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  tmp__34 = tmp__33;
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 152 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 154 "../../../../Macaulay2/d/ffi.d"
	  tmp__34 = expr_WrongArg_1(3, str__13);
	  # line 154 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 154 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 154 "../../../../Macaulay2/d/ffi.d"
	tmp__35 = tmp__34;
	# line 154 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 154 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 155 "../../../../Macaulay2/d/ffi.d"
	tmp__35 = WrongArgPointer_1(2);
	# line 155 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 155 "../../../../Macaulay2/d/ffi.d"
	};
      # line 155 "../../../../Macaulay2/d/ffi.d"
      tmp__36 = tmp__35;
      # line 155 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 155 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 156 "../../../../Macaulay2/d/ffi.d"
      tmp__36 = expr_WrongArgZZ_1(1);
      # line 156 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 156 "../../../../Macaulay2/d/ffi.d"
      };
    # line 156 "../../../../Macaulay2/d/ffi.d"
    tmp__37 = tmp__36;
    # line 156 "../../../../Macaulay2/d/ffi.d"
    goto L30_;
    # line 156 "../../../../Macaulay2/d/ffi.d"
    L24_:;
    # line 137 "../../../../Macaulay2/d/ffi.d"
    tmp__37 = expr_WrongNumArgs_1(3);
    # line 137 "../../../../Macaulay2/d/ffi.d"
    L30_:;
    # line 137 "../../../../Macaulay2/d/ffi.d"
    tmp__38 = tmp__37;
    # line 137 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 137 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 157 "../../../../Macaulay2/d/ffi.d"
    tmp__38 = expr_WrongNumArgs_1(3);
    # line 157 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 157 "../../../../Macaulay2/d/ffi.d"
    };
  # line 157 "../../../../Macaulay2/d/ffi.d"
  return tmp__38;
  # line 157 "../../../../Macaulay2/d/ffi.d"
  }
# line 157 "../../../../Macaulay2/d/ffi.d"
static M2_string str__14;
# line 163 "../../../../Macaulay2/d/ffi.d"
static void * endianAdjust(void * ptr,void * rtype){
  # line 163 "../../../../Macaulay2/d/ffi.d"
  int offset;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  char tmp__39;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  void * tmp__40;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  void * tmp__41;
  # line 163 "../../../../Macaulay2/d/ffi.d"
  if ((__BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__)) goto L31_;
  # line 166 "../../../../Macaulay2/d/ffi.d"
  offset = sizeof(ffi_arg) - ((ffi_type *)rtype)->size;
  # line 168 "../../../../Macaulay2/d/ffi.d"
  tmp__39 = (((ffi_type *)rtype)->type == FFI_TYPE_FLOAT);
  # line 168 "../../../../Macaulay2/d/ffi.d"
  if (tmp__39) goto L33_;
  # line 169 "../../../../Macaulay2/d/ffi.d"
  tmp__39 = (offset <= 0);
  # line 169 "../../../../Macaulay2/d/ffi.d"
  L33_:;
  # line 169 "../../../../Macaulay2/d/ffi.d"
  if (tmp__39) goto L32_;
  # line 171 "../../../../Macaulay2/d/ffi.d"
  tmp__40 = ptr + offset;
  # line 171 "../../../../Macaulay2/d/ffi.d"
  goto L34_;
  # line 171 "../../../../Macaulay2/d/ffi.d"
  L32_:;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  tmp__40 = ptr;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  L34_:;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  tmp__41 = tmp__40;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  goto L35_;
  # line 170 "../../../../Macaulay2/d/ffi.d"
  L31_:;
  # line 164 "../../../../Macaulay2/d/ffi.d"
  tmp__41 = ptr;
  # line 164 "../../../../Macaulay2/d/ffi.d"
  L35_:;
  # line 164 "../../../../Macaulay2/d/ffi.d"
  return tmp__41;
  # line 164 "../../../../Macaulay2/d/ffi.d"
  }
# line 164 "../../../../Macaulay2/d/ffi.d"
static M2_string str__15;
# line 174 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiCall(parse_Expr e){
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_3;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell cif_2;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell fn;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_2;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_List z_2;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  void * rvalue;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  int i_2;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell p;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * avalues;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__42;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__43;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__44;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__45;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__46;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  int tmp__47;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__48;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  void * tmp__49;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__50;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__51;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__52;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__53;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__54;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__55;
  # line 174 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 174 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 174 "../../../../Macaulay2/d/ffi.d"
    a_3 = ((parse_Sequence)e);
    # line 176 "../../../../Macaulay2/d/ffi.d"
    if ((a_3->len != 4)) goto L36_;
    # line 177 "../../../../Macaulay2/d/ffi.d"
    tmp__42 = a_3->array[0];
    # line 177 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__42->type_) {;
      # line 177 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 177 "../../../../Macaulay2/d/ffi.d"
      cif_2 = ((parse_pointerCell)tmp__42);
      # line 178 "../../../../Macaulay2/d/ffi.d"
      tmp__43 = a_3->array[1];
      # line 178 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__43->type_) {;
	# line 178 "../../../../Macaulay2/d/ffi.d"
	case 81:;
	# line 178 "../../../../Macaulay2/d/ffi.d"
	fn = ((parse_pointerCell)tmp__43);
	# line 179 "../../../../Macaulay2/d/ffi.d"
	tmp__44 = a_3->array[2];
	# line 179 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__44->type_) {;
	  # line 179 "../../../../Macaulay2/d/ffi.d"
	  case 3:;
	  # line 179 "../../../../Macaulay2/d/ffi.d"
	  n_2 = ((gmp_ZZcell)tmp__44);
	  # line 180 "../../../../Macaulay2/d/ffi.d"
	  tmp__45 = a_3->array[3];
	  # line 180 "../../../../Macaulay2/d/ffi.d"
	  switch (tmp__45->type_) {;
	    # line 180 "../../../../Macaulay2/d/ffi.d"
	    case 46:;
	    # line 180 "../../../../Macaulay2/d/ffi.d"
	    z_2 = ((parse_List)tmp__45);
	    # line 182 "../../../../Macaulay2/d/ffi.d"
	    rvalue = getMem(gmp_toInt_1(n_2));
	    # line 182 "../../../../Macaulay2/d/ffi.d"
	    i_2 = 0;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    tmp__47 = z_2->v->len;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    ;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    tmp__46 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__47)*sizeof(void *)-sizeof(void *));
	    if (0 == tmp__46) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__47)*sizeof(void *)-sizeof(void *));
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    tmp__46->len = tmp__47;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    if ((tmp__47 == 0)) goto L38_;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    L37_:;
	    # line 185 "../../../../Macaulay2/d/ffi.d"
	    tmp__48 = z_2->v->array[i_2];
	    # line 185 "../../../../Macaulay2/d/ffi.d"
	    switch (tmp__48->type_) {;
	      # line 185 "../../../../Macaulay2/d/ffi.d"
	      case 81:;
	      # line 185 "../../../../Macaulay2/d/ffi.d"
	      p = ((parse_pointerCell)tmp__48);
	      # line 186 "../../../../Macaulay2/d/ffi.d"
	      tmp__49 = p->v;
	      # line 186 "../../../../Macaulay2/d/ffi.d"
	      break;
	      # line 186 "../../../../Macaulay2/d/ffi.d"
	      default:;
	      # line 187 "../../../../Macaulay2/d/ffi.d"
	      tmp__49 = ((void *)0);
	      # line 187 "../../../../Macaulay2/d/ffi.d"
	      break;
	      # line 187 "../../../../Macaulay2/d/ffi.d"
	      };
	    # line 187 "../../../../Macaulay2/d/ffi.d"
	    tmp__46->array[i_2] = tmp__49;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    if (((++ i_2) < tmp__47)) goto L39_;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    goto L38_;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    L39_:;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    goto L37_;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    L38_:;
	    # line 184 "../../../../Macaulay2/d/ffi.d"
	    avalues = tmp__46;
	    # line 188 "../../../../Macaulay2/d/ffi.d"
	    ffi_call((ffi_cif *)cif_2->v, fn->v, rvalue, avalues->array);
	    # line 192 "../../../../Macaulay2/d/ffi.d"
	    tmp__50 = toExpr_3(endianAdjust(rvalue, ((ffi_cif *)cif_2->v)->rtype));
	    # line 193 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 193 "../../../../Macaulay2/d/ffi.d"
	    default:;
	    # line 194 "../../../../Macaulay2/d/ffi.d"
	    tmp__50 = expr_WrongArg_1(4, str__15);
	    # line 194 "../../../../Macaulay2/d/ffi.d"
	    break;
	    # line 194 "../../../../Macaulay2/d/ffi.d"
	    };
	  # line 194 "../../../../Macaulay2/d/ffi.d"
	  tmp__51 = tmp__50;
	  # line 194 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 194 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 195 "../../../../Macaulay2/d/ffi.d"
	  tmp__51 = expr_WrongArgZZ_1(3);
	  # line 195 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 195 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 195 "../../../../Macaulay2/d/ffi.d"
	tmp__52 = tmp__51;
	# line 195 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 195 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 196 "../../../../Macaulay2/d/ffi.d"
	tmp__52 = WrongArgPointer_1(2);
	# line 196 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 196 "../../../../Macaulay2/d/ffi.d"
	};
      # line 196 "../../../../Macaulay2/d/ffi.d"
      tmp__53 = tmp__52;
      # line 196 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 196 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 197 "../../../../Macaulay2/d/ffi.d"
      tmp__53 = WrongArgPointer_1(1);
      # line 197 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 197 "../../../../Macaulay2/d/ffi.d"
      };
    # line 197 "../../../../Macaulay2/d/ffi.d"
    tmp__54 = tmp__53;
    # line 197 "../../../../Macaulay2/d/ffi.d"
    goto L40_;
    # line 197 "../../../../Macaulay2/d/ffi.d"
    L36_:;
    # line 176 "../../../../Macaulay2/d/ffi.d"
    tmp__54 = expr_WrongNumArgs_1(4);
    # line 176 "../../../../Macaulay2/d/ffi.d"
    L40_:;
    # line 176 "../../../../Macaulay2/d/ffi.d"
    tmp__55 = tmp__54;
    # line 176 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 176 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 198 "../../../../Macaulay2/d/ffi.d"
    tmp__55 = expr_WrongNumArgs_1(4);
    # line 198 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 198 "../../../../Macaulay2/d/ffi.d"
    };
  # line 198 "../../../../Macaulay2/d/ffi.d"
  return tmp__55;
  # line 198 "../../../../Macaulay2/d/ffi.d"
  }
# line 198 "../../../../Macaulay2/d/ffi.d"
static M2_string str__16;
# line 198 "../../../../Macaulay2/d/ffi.d"
static M2_string str__17;
# line 198 "../../../../Macaulay2/d/ffi.d"
static M2_string str__18;
# line 198 "../../../../Macaulay2/d/ffi.d"
static M2_string str__19;
# line 214 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiIntegerType(parse_Expr e){
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_4;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_3;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Boolean signed_1;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  int bits;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__56;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__57;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__58;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__59;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__60;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__61;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__62;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__63;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__64;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__65;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__66;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__67;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__68;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__69;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__70;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__71;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__72;
  # line 214 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 214 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 214 "../../../../Macaulay2/d/ffi.d"
    a_4 = ((parse_Sequence)e);
    # line 216 "../../../../Macaulay2/d/ffi.d"
    if ((a_4->len == 2)) goto L41_;
    # line 249 "../../../../Macaulay2/d/ffi.d"
    tmp__56 = expr_WrongNumArgs_1(2);
    # line 249 "../../../../Macaulay2/d/ffi.d"
    goto L42_;
    # line 249 "../../../../Macaulay2/d/ffi.d"
    L41_:;
    # line 217 "../../../../Macaulay2/d/ffi.d"
    tmp__57 = a_4->array[0];
    # line 217 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__57->type_) {;
      # line 217 "../../../../Macaulay2/d/ffi.d"
      case 3:;
      # line 217 "../../../../Macaulay2/d/ffi.d"
      n_3 = ((gmp_ZZcell)tmp__57);
      # line 219 "../../../../Macaulay2/d/ffi.d"
      if ((!(gmp_isInt_1(n_3)))) goto L43_;
      # line 221 "../../../../Macaulay2/d/ffi.d"
      if (gmp_isZero(n_3->v)) goto L44_;
      # line 223 "../../../../Macaulay2/d/ffi.d"
      tmp__58 = a_4->array[1];
      # line 223 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__58->type_) {;
	# line 223 "../../../../Macaulay2/d/ffi.d"
	case 5:;
	# line 223 "../../../../Macaulay2/d/ffi.d"
	signed_1 = ((parse_Boolean)tmp__58);
	# line 225 "../../../../Macaulay2/d/ffi.d"
	bits = gmp_toInt_1(n_3);
	# line 226 "../../../../Macaulay2/d/ffi.d"
	if (signed_1->v) goto L45_;
	# line 237 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 8)) goto L46_;
	# line 239 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 16)) goto L47_;
	# line 241 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 32)) goto L48_;
	# line 243 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 64)) goto L49_;
	# line 245 "../../../../Macaulay2/d/ffi.d"
	tmp__59 = expr_buildErrorPacket(str__18);
	# line 245 "../../../../Macaulay2/d/ffi.d"
	goto L50_;
	# line 245 "../../../../Macaulay2/d/ffi.d"
	L49_:;
	# line 244 "../../../../Macaulay2/d/ffi.d"
	tmp__59 = toExpr_3(&ffi_type_uint64);
	# line 244 "../../../../Macaulay2/d/ffi.d"
	L50_:;
	# line 244 "../../../../Macaulay2/d/ffi.d"
	tmp__60 = tmp__59;
	# line 244 "../../../../Macaulay2/d/ffi.d"
	goto L51_;
	# line 244 "../../../../Macaulay2/d/ffi.d"
	L48_:;
	# line 242 "../../../../Macaulay2/d/ffi.d"
	tmp__60 = toExpr_3(&ffi_type_uint32);
	# line 242 "../../../../Macaulay2/d/ffi.d"
	L51_:;
	# line 242 "../../../../Macaulay2/d/ffi.d"
	tmp__61 = tmp__60;
	# line 242 "../../../../Macaulay2/d/ffi.d"
	goto L52_;
	# line 242 "../../../../Macaulay2/d/ffi.d"
	L47_:;
	# line 240 "../../../../Macaulay2/d/ffi.d"
	tmp__61 = toExpr_3(&ffi_type_uint16);
	# line 240 "../../../../Macaulay2/d/ffi.d"
	L52_:;
	# line 240 "../../../../Macaulay2/d/ffi.d"
	tmp__62 = tmp__61;
	# line 240 "../../../../Macaulay2/d/ffi.d"
	goto L53_;
	# line 240 "../../../../Macaulay2/d/ffi.d"
	L46_:;
	# line 238 "../../../../Macaulay2/d/ffi.d"
	tmp__62 = toExpr_3(&ffi_type_uint8);
	# line 238 "../../../../Macaulay2/d/ffi.d"
	L53_:;
	# line 238 "../../../../Macaulay2/d/ffi.d"
	tmp__63 = tmp__62;
	# line 238 "../../../../Macaulay2/d/ffi.d"
	goto L54_;
	# line 238 "../../../../Macaulay2/d/ffi.d"
	L45_:;
	# line 227 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 8)) goto L55_;
	# line 229 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 16)) goto L56_;
	# line 231 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 32)) goto L57_;
	# line 233 "../../../../Macaulay2/d/ffi.d"
	if ((bits == 64)) goto L58_;
	# line 235 "../../../../Macaulay2/d/ffi.d"
	tmp__64 = expr_buildErrorPacket(str__19);
	# line 235 "../../../../Macaulay2/d/ffi.d"
	goto L59_;
	# line 235 "../../../../Macaulay2/d/ffi.d"
	L58_:;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	tmp__64 = toExpr_3(&ffi_type_sint64);
	# line 234 "../../../../Macaulay2/d/ffi.d"
	L59_:;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	tmp__65 = tmp__64;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	goto L60_;
	# line 234 "../../../../Macaulay2/d/ffi.d"
	L57_:;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	tmp__65 = toExpr_3(&ffi_type_sint32);
	# line 232 "../../../../Macaulay2/d/ffi.d"
	L60_:;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	tmp__66 = tmp__65;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	goto L61_;
	# line 232 "../../../../Macaulay2/d/ffi.d"
	L56_:;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	tmp__66 = toExpr_3(&ffi_type_sint16);
	# line 230 "../../../../Macaulay2/d/ffi.d"
	L61_:;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	tmp__67 = tmp__66;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	goto L62_;
	# line 230 "../../../../Macaulay2/d/ffi.d"
	L55_:;
	# line 228 "../../../../Macaulay2/d/ffi.d"
	tmp__67 = toExpr_3(&ffi_type_sint8);
	# line 228 "../../../../Macaulay2/d/ffi.d"
	L62_:;
	# line 228 "../../../../Macaulay2/d/ffi.d"
	tmp__63 = tmp__67;
	# line 228 "../../../../Macaulay2/d/ffi.d"
	L54_:;
	# line 228 "../../../../Macaulay2/d/ffi.d"
	tmp__68 = tmp__63;
	# line 228 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 228 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 247 "../../../../Macaulay2/d/ffi.d"
	tmp__68 = expr_WrongArgBoolean_1(2);
	# line 247 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 247 "../../../../Macaulay2/d/ffi.d"
	};
      # line 247 "../../../../Macaulay2/d/ffi.d"
      tmp__69 = tmp__68;
      # line 247 "../../../../Macaulay2/d/ffi.d"
      goto L63_;
      # line 247 "../../../../Macaulay2/d/ffi.d"
      L44_:;
      # line 222 "../../../../Macaulay2/d/ffi.d"
      tmp__69 = toExpr_3(&ffi_type_pointer);
      # line 222 "../../../../Macaulay2/d/ffi.d"
      L63_:;
      # line 222 "../../../../Macaulay2/d/ffi.d"
      tmp__70 = tmp__69;
      # line 222 "../../../../Macaulay2/d/ffi.d"
      goto L64_;
      # line 222 "../../../../Macaulay2/d/ffi.d"
      L43_:;
      # line 220 "../../../../Macaulay2/d/ffi.d"
      tmp__70 = expr_WrongArgSmallInteger_1(1);
      # line 220 "../../../../Macaulay2/d/ffi.d"
      L64_:;
      # line 220 "../../../../Macaulay2/d/ffi.d"
      tmp__71 = tmp__70;
      # line 220 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 220 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 248 "../../../../Macaulay2/d/ffi.d"
      tmp__71 = expr_WrongArgZZ_1(1);
      # line 248 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 248 "../../../../Macaulay2/d/ffi.d"
      };
    # line 248 "../../../../Macaulay2/d/ffi.d"
    tmp__56 = tmp__71;
    # line 248 "../../../../Macaulay2/d/ffi.d"
    L42_:;
    # line 248 "../../../../Macaulay2/d/ffi.d"
    tmp__72 = tmp__56;
    # line 248 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 248 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 250 "../../../../Macaulay2/d/ffi.d"
    tmp__72 = expr_WrongNumArgs_1(2);
    # line 250 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 250 "../../../../Macaulay2/d/ffi.d"
    };
  # line 250 "../../../../Macaulay2/d/ffi.d"
  return tmp__72;
  # line 250 "../../../../Macaulay2/d/ffi.d"
  }
# line 250 "../../../../Macaulay2/d/ffi.d"
static M2_string str__20;
# line 250 "../../../../Macaulay2/d/ffi.d"
static M2_string str__21;
# line 250 "../../../../Macaulay2/d/ffi.d"
static M2_string str__22;
# line 258 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiIntegerAddress(parse_Expr e){
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_5;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell x_5;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_4;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Boolean signed_2;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  int bits_1;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  void * ptr_1;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  mpz_ptr z_3;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  void * ptr_2;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__73;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__74;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__75;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__76;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__77;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__78;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__79;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__80;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__81;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__82;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__83;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__84;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__85;
  # line 258 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 258 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 258 "../../../../Macaulay2/d/ffi.d"
    a_5 = ((parse_Sequence)e);
    # line 260 "../../../../Macaulay2/d/ffi.d"
    if ((a_5->len == 3)) goto L65_;
    # line 314 "../../../../Macaulay2/d/ffi.d"
    tmp__73 = expr_WrongNumArgs_1(3);
    # line 314 "../../../../Macaulay2/d/ffi.d"
    goto L66_;
    # line 314 "../../../../Macaulay2/d/ffi.d"
    L65_:;
    # line 261 "../../../../Macaulay2/d/ffi.d"
    tmp__74 = a_5->array[0];
    # line 261 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__74->type_) {;
      # line 261 "../../../../Macaulay2/d/ffi.d"
      case 3:;
      # line 261 "../../../../Macaulay2/d/ffi.d"
      x_5 = ((gmp_ZZcell)tmp__74);
      # line 263 "../../../../Macaulay2/d/ffi.d"
      tmp__75 = a_5->array[1];
      # line 263 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__75->type_) {;
	# line 263 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 263 "../../../../Macaulay2/d/ffi.d"
	y_4 = ((gmp_ZZcell)tmp__75);
	# line 265 "../../../../Macaulay2/d/ffi.d"
	if ((!(gmp_isInt_1(y_4)))) goto L67_;
	# line 267 "../../../../Macaulay2/d/ffi.d"
	if (gmp_isZero(y_4->v)) goto L68_;
	# line 275 "../../../../Macaulay2/d/ffi.d"
	tmp__76 = a_5->array[2];
	# line 275 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__76->type_) {;
	  # line 275 "../../../../Macaulay2/d/ffi.d"
	  case 5:;
	  # line 275 "../../../../Macaulay2/d/ffi.d"
	  signed_2 = ((parse_Boolean)tmp__76);
	  # line 277 "../../../../Macaulay2/d/ffi.d"
	  bits_1 = gmp_toInt_1(y_4);
	  # line 278 "../../../../Macaulay2/d/ffi.d"
	  ptr_1 = getMemAtomic((bits_1 / 8));
	  # line 279 "../../../../Macaulay2/d/ffi.d"
	  if (signed_2->v) goto L69_;
	  # line 296 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 8)) goto L70_;
	  # line 299 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 16)) goto L71_;
	  # line 302 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 32)) goto L72_;
	  # line 305 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 64)) goto L73_;
	  # line 308 "../../../../Macaulay2/d/ffi.d"
	  tmp__77 = expr_buildErrorPacket(str__21);
	  # line 308 "../../../../Macaulay2/d/ffi.d"
	  return tmp__77;
	  # line 308 "../../../../Macaulay2/d/ffi.d"
	  L73_:;
	  # line 306 "../../../../Macaulay2/d/ffi.d"
	  *(uint64_t *)ptr_1 = gmp_toUInt64_1(x_5);
	  # line 307 "../../../../Macaulay2/d/ffi.d"
	  goto L74_;
	  # line 307 "../../../../Macaulay2/d/ffi.d"
	  L72_:;
	  # line 303 "../../../../Macaulay2/d/ffi.d"
	  *(uint32_t *)ptr_1 = gmp_toULong_1(x_5);
	  # line 304 "../../../../Macaulay2/d/ffi.d"
	  L74_:;
	  # line 304 "../../../../Macaulay2/d/ffi.d"
	  goto L75_;
	  # line 304 "../../../../Macaulay2/d/ffi.d"
	  L71_:;
	  # line 300 "../../../../Macaulay2/d/ffi.d"
	  *(uint16_t *)ptr_1 = gmp_toUInt_1(x_5);
	  # line 301 "../../../../Macaulay2/d/ffi.d"
	  L75_:;
	  # line 301 "../../../../Macaulay2/d/ffi.d"
	  goto L76_;
	  # line 301 "../../../../Macaulay2/d/ffi.d"
	  L70_:;
	  # line 297 "../../../../Macaulay2/d/ffi.d"
	  *(uint8_t *)ptr_1 = gmp_toUInt_1(x_5);
	  # line 298 "../../../../Macaulay2/d/ffi.d"
	  L76_:;
	  # line 310 "../../../../Macaulay2/d/ffi.d"
	  tmp__78 = toExpr_3(ptr_1);
	  # line 310 "../../../../Macaulay2/d/ffi.d"
	  goto L77_;
	  # line 310 "../../../../Macaulay2/d/ffi.d"
	  L69_:;
	  # line 280 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 8)) goto L78_;
	  # line 283 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 16)) goto L79_;
	  # line 286 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 32)) goto L80_;
	  # line 289 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_1 == 64)) goto L81_;
	  # line 292 "../../../../Macaulay2/d/ffi.d"
	  tmp__79 = expr_buildErrorPacket(str__22);
	  # line 292 "../../../../Macaulay2/d/ffi.d"
	  return tmp__79;
	  # line 292 "../../../../Macaulay2/d/ffi.d"
	  L81_:;
	  # line 290 "../../../../Macaulay2/d/ffi.d"
	  *(int64_t *)ptr_1 = gmp_toInt64_1(x_5);
	  # line 291 "../../../../Macaulay2/d/ffi.d"
	  goto L82_;
	  # line 291 "../../../../Macaulay2/d/ffi.d"
	  L80_:;
	  # line 287 "../../../../Macaulay2/d/ffi.d"
	  *(int32_t *)ptr_1 = gmp_toLong_1(x_5);
	  # line 288 "../../../../Macaulay2/d/ffi.d"
	  L82_:;
	  # line 288 "../../../../Macaulay2/d/ffi.d"
	  goto L83_;
	  # line 288 "../../../../Macaulay2/d/ffi.d"
	  L79_:;
	  # line 284 "../../../../Macaulay2/d/ffi.d"
	  *(int16_t *)ptr_1 = gmp_toInt_1(x_5);
	  # line 285 "../../../../Macaulay2/d/ffi.d"
	  L83_:;
	  # line 285 "../../../../Macaulay2/d/ffi.d"
	  goto L84_;
	  # line 285 "../../../../Macaulay2/d/ffi.d"
	  L78_:;
	  # line 281 "../../../../Macaulay2/d/ffi.d"
	  *(int8_t *)ptr_1 = gmp_toInt_1(x_5);
	  # line 282 "../../../../Macaulay2/d/ffi.d"
	  L84_:;
	  # line 294 "../../../../Macaulay2/d/ffi.d"
	  tmp__78 = toExpr_3(ptr_1);
	  # line 294 "../../../../Macaulay2/d/ffi.d"
	  L77_:;
	  # line 294 "../../../../Macaulay2/d/ffi.d"
	  tmp__80 = tmp__78;
	  # line 294 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 294 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  tmp__80 = expr_WrongArgBoolean_1(3);
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 311 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 311 "../../../../Macaulay2/d/ffi.d"
	tmp__81 = tmp__80;
	# line 311 "../../../../Macaulay2/d/ffi.d"
	goto L85_;
	# line 311 "../../../../Macaulay2/d/ffi.d"
	L68_:;
	# line 268 "../../../../Macaulay2/d/ffi.d"
	z_3 = gmp_newZZmutable();
	# line 269 "../../../../Macaulay2/d/ffi.d"
	mpz_set   (z_3,x_5->v);
	# line 270 "../../../../Macaulay2/d/ffi.d"
	ptr_2 = getMem(pointerSize);
	# line 271 "../../../../Macaulay2/d/ffi.d"
	*(mpz_ptr *)ptr_2 = z_3;
	# line 272 "../../../../Macaulay2/d/ffi.d"
	GC_REGISTER_FINALIZER(ptr_2, (GC_finalization_proc)mpz_clear, z_3, 0, 0);
	# line 274 "../../../../Macaulay2/d/ffi.d"
	tmp__81 = toExpr_3(ptr_2);
	# line 274 "../../../../Macaulay2/d/ffi.d"
	L85_:;
	# line 274 "../../../../Macaulay2/d/ffi.d"
	tmp__82 = tmp__81;
	# line 274 "../../../../Macaulay2/d/ffi.d"
	goto L86_;
	# line 274 "../../../../Macaulay2/d/ffi.d"
	L67_:;
	# line 266 "../../../../Macaulay2/d/ffi.d"
	tmp__82 = expr_WrongArgSmallInteger_1(2);
	# line 266 "../../../../Macaulay2/d/ffi.d"
	L86_:;
	# line 266 "../../../../Macaulay2/d/ffi.d"
	tmp__83 = tmp__82;
	# line 266 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 266 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 312 "../../../../Macaulay2/d/ffi.d"
	tmp__83 = expr_WrongArgZZ_1(2);
	# line 312 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 312 "../../../../Macaulay2/d/ffi.d"
	};
      # line 312 "../../../../Macaulay2/d/ffi.d"
      tmp__84 = tmp__83;
      # line 312 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 312 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 313 "../../../../Macaulay2/d/ffi.d"
      tmp__84 = expr_WrongArgZZ_1(1);
      # line 313 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 313 "../../../../Macaulay2/d/ffi.d"
      };
    # line 313 "../../../../Macaulay2/d/ffi.d"
    tmp__73 = tmp__84;
    # line 313 "../../../../Macaulay2/d/ffi.d"
    L66_:;
    # line 313 "../../../../Macaulay2/d/ffi.d"
    tmp__85 = tmp__73;
    # line 313 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 313 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 315 "../../../../Macaulay2/d/ffi.d"
    tmp__85 = expr_WrongNumArgs_1(3);
    # line 315 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 315 "../../../../Macaulay2/d/ffi.d"
    };
  # line 315 "../../../../Macaulay2/d/ffi.d"
  return tmp__85;
  # line 315 "../../../../Macaulay2/d/ffi.d"
  }
# line 315 "../../../../Macaulay2/d/ffi.d"
static M2_string str__23;
# line 315 "../../../../Macaulay2/d/ffi.d"
static M2_string str__24;
# line 315 "../../../../Macaulay2/d/ffi.d"
static M2_string str__25;
# line 323 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiIntegerValue(parse_Expr e){
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_6;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_6;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_5;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Boolean signed_3;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  int bits_2;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__86;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__87;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__88;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__89;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__90;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__91;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__92;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__93;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__94;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__95;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__96;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__97;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__98;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__99;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__100;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__101;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__102;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__103;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__104;
  # line 323 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 323 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 323 "../../../../Macaulay2/d/ffi.d"
    a_6 = ((parse_Sequence)e);
    # line 325 "../../../../Macaulay2/d/ffi.d"
    if ((a_6->len == 3)) goto L87_;
    # line 362 "../../../../Macaulay2/d/ffi.d"
    tmp__86 = expr_WrongNumArgs_1(3);
    # line 362 "../../../../Macaulay2/d/ffi.d"
    goto L88_;
    # line 362 "../../../../Macaulay2/d/ffi.d"
    L87_:;
    # line 326 "../../../../Macaulay2/d/ffi.d"
    tmp__87 = a_6->array[0];
    # line 326 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__87->type_) {;
      # line 326 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 326 "../../../../Macaulay2/d/ffi.d"
      x_6 = ((parse_pointerCell)tmp__87);
      # line 328 "../../../../Macaulay2/d/ffi.d"
      tmp__88 = a_6->array[1];
      # line 328 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__88->type_) {;
	# line 328 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 328 "../../../../Macaulay2/d/ffi.d"
	y_5 = ((gmp_ZZcell)tmp__88);
	# line 330 "../../../../Macaulay2/d/ffi.d"
	if ((!(gmp_isInt_1(y_5)))) goto L89_;
	# line 332 "../../../../Macaulay2/d/ffi.d"
	if (gmp_isZero(y_5->v)) goto L90_;
	# line 334 "../../../../Macaulay2/d/ffi.d"
	tmp__89 = a_6->array[2];
	# line 334 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__89->type_) {;
	  # line 334 "../../../../Macaulay2/d/ffi.d"
	  case 5:;
	  # line 334 "../../../../Macaulay2/d/ffi.d"
	  signed_3 = ((parse_Boolean)tmp__89);
	  # line 336 "../../../../Macaulay2/d/ffi.d"
	  bits_2 = gmp_toInt_1(y_5);
	  # line 337 "../../../../Macaulay2/d/ffi.d"
	  if (signed_3->v) goto L91_;
	  # line 349 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 8)) goto L92_;
	  # line 351 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 16)) goto L93_;
	  # line 353 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 32)) goto L94_;
	  # line 355 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 64)) goto L95_;
	  # line 357 "../../../../Macaulay2/d/ffi.d"
	  tmp__90 = expr_buildErrorPacket(str__24);
	  # line 357 "../../../../Macaulay2/d/ffi.d"
	  goto L96_;
	  # line 357 "../../../../Macaulay2/d/ffi.d"
	  L95_:;
	  # line 356 "../../../../Macaulay2/d/ffi.d"
	  tmp__90 = util_toExpr_11(*(uint64_t *)x_6->v);
	  # line 356 "../../../../Macaulay2/d/ffi.d"
	  L96_:;
	  # line 356 "../../../../Macaulay2/d/ffi.d"
	  tmp__91 = tmp__90;
	  # line 356 "../../../../Macaulay2/d/ffi.d"
	  goto L97_;
	  # line 356 "../../../../Macaulay2/d/ffi.d"
	  L94_:;
	  # line 354 "../../../../Macaulay2/d/ffi.d"
	  tmp__91 = util_toExpr_9(*(uint32_t *)x_6->v);
	  # line 354 "../../../../Macaulay2/d/ffi.d"
	  L97_:;
	  # line 354 "../../../../Macaulay2/d/ffi.d"
	  tmp__92 = tmp__91;
	  # line 354 "../../../../Macaulay2/d/ffi.d"
	  goto L98_;
	  # line 354 "../../../../Macaulay2/d/ffi.d"
	  L93_:;
	  # line 352 "../../../../Macaulay2/d/ffi.d"
	  tmp__92 = util_toExpr_7(*(uint16_t *)x_6->v);
	  # line 352 "../../../../Macaulay2/d/ffi.d"
	  L98_:;
	  # line 352 "../../../../Macaulay2/d/ffi.d"
	  tmp__93 = tmp__92;
	  # line 352 "../../../../Macaulay2/d/ffi.d"
	  goto L99_;
	  # line 352 "../../../../Macaulay2/d/ffi.d"
	  L92_:;
	  # line 350 "../../../../Macaulay2/d/ffi.d"
	  tmp__93 = util_toExpr_5(*(uint8_t *)x_6->v);
	  # line 350 "../../../../Macaulay2/d/ffi.d"
	  L99_:;
	  # line 350 "../../../../Macaulay2/d/ffi.d"
	  tmp__94 = tmp__93;
	  # line 350 "../../../../Macaulay2/d/ffi.d"
	  goto L100_;
	  # line 350 "../../../../Macaulay2/d/ffi.d"
	  L91_:;
	  # line 338 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 8)) goto L101_;
	  # line 340 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 16)) goto L102_;
	  # line 342 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 32)) goto L103_;
	  # line 344 "../../../../Macaulay2/d/ffi.d"
	  if ((bits_2 == 64)) goto L104_;
	  # line 346 "../../../../Macaulay2/d/ffi.d"
	  tmp__95 = expr_buildErrorPacket(str__25);
	  # line 346 "../../../../Macaulay2/d/ffi.d"
	  goto L105_;
	  # line 346 "../../../../Macaulay2/d/ffi.d"
	  L104_:;
	  # line 345 "../../../../Macaulay2/d/ffi.d"
	  tmp__95 = util_toExpr_10(*(int64_t *)x_6->v);
	  # line 345 "../../../../Macaulay2/d/ffi.d"
	  L105_:;
	  # line 345 "../../../../Macaulay2/d/ffi.d"
	  tmp__96 = tmp__95;
	  # line 345 "../../../../Macaulay2/d/ffi.d"
	  goto L106_;
	  # line 345 "../../../../Macaulay2/d/ffi.d"
	  L103_:;
	  # line 343 "../../../../Macaulay2/d/ffi.d"
	  tmp__96 = util_toExpr_8(*(int32_t *)x_6->v);
	  # line 343 "../../../../Macaulay2/d/ffi.d"
	  L106_:;
	  # line 343 "../../../../Macaulay2/d/ffi.d"
	  tmp__97 = tmp__96;
	  # line 343 "../../../../Macaulay2/d/ffi.d"
	  goto L107_;
	  # line 343 "../../../../Macaulay2/d/ffi.d"
	  L102_:;
	  # line 341 "../../../../Macaulay2/d/ffi.d"
	  tmp__97 = util_toExpr_6(*(int16_t *)x_6->v);
	  # line 341 "../../../../Macaulay2/d/ffi.d"
	  L107_:;
	  # line 341 "../../../../Macaulay2/d/ffi.d"
	  tmp__98 = tmp__97;
	  # line 341 "../../../../Macaulay2/d/ffi.d"
	  goto L108_;
	  # line 341 "../../../../Macaulay2/d/ffi.d"
	  L101_:;
	  # line 339 "../../../../Macaulay2/d/ffi.d"
	  tmp__98 = util_toExpr_4(*(int8_t *)x_6->v);
	  # line 339 "../../../../Macaulay2/d/ffi.d"
	  L108_:;
	  # line 339 "../../../../Macaulay2/d/ffi.d"
	  tmp__94 = tmp__98;
	  # line 339 "../../../../Macaulay2/d/ffi.d"
	  L100_:;
	  # line 339 "../../../../Macaulay2/d/ffi.d"
	  tmp__99 = tmp__94;
	  # line 339 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 339 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 359 "../../../../Macaulay2/d/ffi.d"
	  tmp__99 = expr_WrongArgBoolean_1(3);
	  # line 359 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 359 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 359 "../../../../Macaulay2/d/ffi.d"
	tmp__100 = tmp__99;
	# line 359 "../../../../Macaulay2/d/ffi.d"
	goto L109_;
	# line 359 "../../../../Macaulay2/d/ffi.d"
	L90_:;
	# line 333 "../../../../Macaulay2/d/ffi.d"
	tmp__100 = util_toExpr_13(gmp_moveToZZ(*(mpz_ptr*)x_6->v));
	# line 333 "../../../../Macaulay2/d/ffi.d"
	L109_:;
	# line 333 "../../../../Macaulay2/d/ffi.d"
	tmp__101 = tmp__100;
	# line 333 "../../../../Macaulay2/d/ffi.d"
	goto L110_;
	# line 333 "../../../../Macaulay2/d/ffi.d"
	L89_:;
	# line 331 "../../../../Macaulay2/d/ffi.d"
	tmp__101 = expr_WrongArgSmallInteger_1(2);
	# line 331 "../../../../Macaulay2/d/ffi.d"
	L110_:;
	# line 331 "../../../../Macaulay2/d/ffi.d"
	tmp__102 = tmp__101;
	# line 331 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 331 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 360 "../../../../Macaulay2/d/ffi.d"
	tmp__102 = expr_WrongArgZZ_1(2);
	# line 360 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 360 "../../../../Macaulay2/d/ffi.d"
	};
      # line 360 "../../../../Macaulay2/d/ffi.d"
      tmp__103 = tmp__102;
      # line 360 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 360 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 361 "../../../../Macaulay2/d/ffi.d"
      tmp__103 = WrongArgPointer_1(1);
      # line 361 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 361 "../../../../Macaulay2/d/ffi.d"
      };
    # line 361 "../../../../Macaulay2/d/ffi.d"
    tmp__86 = tmp__103;
    # line 361 "../../../../Macaulay2/d/ffi.d"
    L88_:;
    # line 361 "../../../../Macaulay2/d/ffi.d"
    tmp__104 = tmp__86;
    # line 361 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 361 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 363 "../../../../Macaulay2/d/ffi.d"
    tmp__104 = expr_WrongNumArgs_1(3);
    # line 363 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 363 "../../../../Macaulay2/d/ffi.d"
    };
  # line 363 "../../../../Macaulay2/d/ffi.d"
  return tmp__104;
  # line 363 "../../../../Macaulay2/d/ffi.d"
  }
# line 363 "../../../../Macaulay2/d/ffi.d"
static M2_string str__26;
# line 363 "../../../../Macaulay2/d/ffi.d"
static M2_string str__27;
# line 373 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiRealType(parse_Expr e){
  # line 373 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell n_4;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  int bits_3;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__105;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__106;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__107;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__108;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__109;
  # line 373 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 373 "../../../../Macaulay2/d/ffi.d"
    case 3:;
    # line 373 "../../../../Macaulay2/d/ffi.d"
    n_4 = ((gmp_ZZcell)e);
    # line 375 "../../../../Macaulay2/d/ffi.d"
    if ((!(gmp_isInt_1(n_4)))) goto L111_;
    # line 375 "../../../../Macaulay2/d/ffi.d"
    goto L112_;
    # line 375 "../../../../Macaulay2/d/ffi.d"
    L111_:;
    # line 375 "../../../../Macaulay2/d/ffi.d"
    tmp__105 = expr_WrongArgSmallInteger();
    # line 375 "../../../../Macaulay2/d/ffi.d"
    return tmp__105;
    # line 375 "../../../../Macaulay2/d/ffi.d"
    L112_:;
    # line 376 "../../../../Macaulay2/d/ffi.d"
    bits_3 = gmp_toInt_1(n_4);
    # line 377 "../../../../Macaulay2/d/ffi.d"
    if ((bits_3 == 0)) goto L113_;
    # line 378 "../../../../Macaulay2/d/ffi.d"
    if ((bits_3 == 32)) goto L114_;
    # line 379 "../../../../Macaulay2/d/ffi.d"
    if ((bits_3 == 64)) goto L115_;
    # line 380 "../../../../Macaulay2/d/ffi.d"
    tmp__106 = expr_buildErrorPacket(str__27);
    # line 380 "../../../../Macaulay2/d/ffi.d"
    goto L116_;
    # line 380 "../../../../Macaulay2/d/ffi.d"
    L115_:;
    # line 379 "../../../../Macaulay2/d/ffi.d"
    tmp__106 = toExpr_3(&ffi_type_double);
    # line 379 "../../../../Macaulay2/d/ffi.d"
    L116_:;
    # line 379 "../../../../Macaulay2/d/ffi.d"
    tmp__107 = tmp__106;
    # line 379 "../../../../Macaulay2/d/ffi.d"
    goto L117_;
    # line 379 "../../../../Macaulay2/d/ffi.d"
    L114_:;
    # line 378 "../../../../Macaulay2/d/ffi.d"
    tmp__107 = toExpr_3(&ffi_type_float);
    # line 378 "../../../../Macaulay2/d/ffi.d"
    L117_:;
    # line 378 "../../../../Macaulay2/d/ffi.d"
    tmp__108 = tmp__107;
    # line 378 "../../../../Macaulay2/d/ffi.d"
    goto L118_;
    # line 378 "../../../../Macaulay2/d/ffi.d"
    L113_:;
    # line 377 "../../../../Macaulay2/d/ffi.d"
    tmp__108 = toExpr_3(&ffi_type_pointer);
    # line 377 "../../../../Macaulay2/d/ffi.d"
    L118_:;
    # line 377 "../../../../Macaulay2/d/ffi.d"
    tmp__109 = tmp__108;
    # line 377 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 377 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 381 "../../../../Macaulay2/d/ffi.d"
    tmp__109 = expr_WrongArgZZ();
    # line 381 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 381 "../../../../Macaulay2/d/ffi.d"
    };
  # line 381 "../../../../Macaulay2/d/ffi.d"
  return tmp__109;
  # line 381 "../../../../Macaulay2/d/ffi.d"
  }
# line 381 "../../../../Macaulay2/d/ffi.d"
static M2_string str__28;
# line 381 "../../../../Macaulay2/d/ffi.d"
static M2_string str__29;
# line 389 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiRealAddress(parse_Expr e){
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_7;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  gmp_RRcell x_7;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_6;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  int bits_4;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  void * ptr_3;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  double z_4;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  float z_5;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  mpfr_ptr z_6;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  void * ptr_4;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__110;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__111;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__112;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__113;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  char tmp__114;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__115;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__116;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__117;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__118;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__119;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__120;
  # line 389 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 389 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 389 "../../../../Macaulay2/d/ffi.d"
    a_7 = ((parse_Sequence)e);
    # line 391 "../../../../Macaulay2/d/ffi.d"
    if ((a_7->len == 2)) goto L119_;
    # line 422 "../../../../Macaulay2/d/ffi.d"
    tmp__110 = expr_WrongNumArgs_1(2);
    # line 422 "../../../../Macaulay2/d/ffi.d"
    goto L120_;
    # line 422 "../../../../Macaulay2/d/ffi.d"
    L119_:;
    # line 392 "../../../../Macaulay2/d/ffi.d"
    tmp__111 = a_7->array[0];
    # line 392 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__111->type_) {;
      # line 392 "../../../../Macaulay2/d/ffi.d"
      case 52:;
      # line 392 "../../../../Macaulay2/d/ffi.d"
      x_7 = ((gmp_RRcell)tmp__111);
      # line 394 "../../../../Macaulay2/d/ffi.d"
      tmp__112 = a_7->array[1];
      # line 394 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__112->type_) {;
	# line 394 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 394 "../../../../Macaulay2/d/ffi.d"
	y_6 = ((gmp_ZZcell)tmp__112);
	# line 396 "../../../../Macaulay2/d/ffi.d"
	if ((!(gmp_isInt_1(y_6)))) goto L121_;
	# line 396 "../../../../Macaulay2/d/ffi.d"
	goto L122_;
	# line 396 "../../../../Macaulay2/d/ffi.d"
	L121_:;
	# line 396 "../../../../Macaulay2/d/ffi.d"
	tmp__113 = expr_WrongArgSmallInteger();
	# line 396 "../../../../Macaulay2/d/ffi.d"
	return tmp__113;
	# line 396 "../../../../Macaulay2/d/ffi.d"
	L122_:;
	# line 397 "../../../../Macaulay2/d/ffi.d"
	bits_4 = gmp_toInt_1(y_6);
	# line 398 "../../../../Macaulay2/d/ffi.d"
	if ((bits_4 == 0)) goto L123_;
	# line 408 "../../../../Macaulay2/d/ffi.d"
	tmp__114 = (bits_4 == 32);
	# line 408 "../../../../Macaulay2/d/ffi.d"
	if (tmp__114) goto L125_;
	# line 408 "../../../../Macaulay2/d/ffi.d"
	tmp__114 = (bits_4 == 64);
	# line 408 "../../../../Macaulay2/d/ffi.d"
	L125_:;
	# line 408 "../../../../Macaulay2/d/ffi.d"
	if (tmp__114) goto L124_;
	# line 419 "../../../../Macaulay2/d/ffi.d"
	tmp__115 = expr_buildErrorPacket(str__29);
	# line 419 "../../../../Macaulay2/d/ffi.d"
	return tmp__115;
	# line 419 "../../../../Macaulay2/d/ffi.d"
	L124_:;
	# line 409 "../../../../Macaulay2/d/ffi.d"
	ptr_3 = getMemAtomic((bits_4 / 8));
	# line 410 "../../../../Macaulay2/d/ffi.d"
	if ((bits_4 == 32)) goto L126_;
	# line 414 "../../../../Macaulay2/d/ffi.d"
	if ((bits_4 == 64)) goto L127_;
	# line 414 "../../../../Macaulay2/d/ffi.d"
	goto L128_;
	# line 414 "../../../../Macaulay2/d/ffi.d"
	L127_:;
	# line 416 "../../../../Macaulay2/d/ffi.d"
	z_4 = gmp_toDouble_5(x_7);
	# line 417 "../../../../Macaulay2/d/ffi.d"
	*(double *)ptr_3 = z_4;
	# line 417 "../../../../Macaulay2/d/ffi.d"
	L128_:;
	# line 417 "../../../../Macaulay2/d/ffi.d"
	goto L129_;
	# line 417 "../../../../Macaulay2/d/ffi.d"
	L126_:;
	# line 412 "../../../../Macaulay2/d/ffi.d"
	z_5 = gmp_toFloat_2(x_7);
	# line 413 "../../../../Macaulay2/d/ffi.d"
	*(float *)ptr_3 = z_5;
	# line 413 "../../../../Macaulay2/d/ffi.d"
	L129_:;
	# line 418 "../../../../Macaulay2/d/ffi.d"
	tmp__116 = toExpr_3(ptr_3);
	# line 418 "../../../../Macaulay2/d/ffi.d"
	tmp__117 = tmp__116;
	# line 418 "../../../../Macaulay2/d/ffi.d"
	goto L130_;
	# line 418 "../../../../Macaulay2/d/ffi.d"
	L123_:;
	# line 399 "../../../../Macaulay2/d/ffi.d"
	z_6 = gmp_newRRmutable(gmp_precision(x_7->v));
	# line 400 "../../../../Macaulay2/d/ffi.d"
	mpfr_set(z_6, x_7->v, MPFR_RNDN);
	# line 401 "../../../../Macaulay2/d/ffi.d"
	ptr_4 = getMem(pointerSize);
	# line 402 "../../../../Macaulay2/d/ffi.d"
	*(mpfr_ptr *)ptr_4 = z_6;
	# line 407 "../../../../Macaulay2/d/ffi.d"
	tmp__117 = toExpr_3(ptr_4);
	# line 407 "../../../../Macaulay2/d/ffi.d"
	L130_:;
	# line 407 "../../../../Macaulay2/d/ffi.d"
	tmp__118 = tmp__117;
	# line 407 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 407 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 420 "../../../../Macaulay2/d/ffi.d"
	tmp__118 = expr_WrongArgZZ_1(2);
	# line 420 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 420 "../../../../Macaulay2/d/ffi.d"
	};
      # line 420 "../../../../Macaulay2/d/ffi.d"
      tmp__119 = tmp__118;
      # line 420 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 420 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 421 "../../../../Macaulay2/d/ffi.d"
      tmp__119 = expr_WrongArgRR_1(1);
      # line 421 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 421 "../../../../Macaulay2/d/ffi.d"
      };
    # line 421 "../../../../Macaulay2/d/ffi.d"
    tmp__110 = tmp__119;
    # line 421 "../../../../Macaulay2/d/ffi.d"
    L120_:;
    # line 421 "../../../../Macaulay2/d/ffi.d"
    tmp__120 = tmp__110;
    # line 421 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 421 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 423 "../../../../Macaulay2/d/ffi.d"
    tmp__120 = expr_WrongNumArgs_1(2);
    # line 423 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 423 "../../../../Macaulay2/d/ffi.d"
    };
  # line 423 "../../../../Macaulay2/d/ffi.d"
  return tmp__120;
  # line 423 "../../../../Macaulay2/d/ffi.d"
  }
# line 423 "../../../../Macaulay2/d/ffi.d"
static M2_string str__30;
# line 423 "../../../../Macaulay2/d/ffi.d"
static M2_string str__31;
# line 431 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiRealValue(parse_Expr e){
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_8;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_8;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  gmp_ZZcell y_7;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  int bits_5;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__121;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__122;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__123;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__124;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__125;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__126;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__127;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__128;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__129;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__130;
  # line 431 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 431 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 431 "../../../../Macaulay2/d/ffi.d"
    a_8 = ((parse_Sequence)e);
    # line 433 "../../../../Macaulay2/d/ffi.d"
    if ((a_8->len == 2)) goto L131_;
    # line 449 "../../../../Macaulay2/d/ffi.d"
    tmp__121 = expr_WrongNumArgs_1(2);
    # line 449 "../../../../Macaulay2/d/ffi.d"
    goto L132_;
    # line 449 "../../../../Macaulay2/d/ffi.d"
    L131_:;
    # line 434 "../../../../Macaulay2/d/ffi.d"
    tmp__122 = a_8->array[0];
    # line 434 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__122->type_) {;
      # line 434 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 434 "../../../../Macaulay2/d/ffi.d"
      x_8 = ((parse_pointerCell)tmp__122);
      # line 436 "../../../../Macaulay2/d/ffi.d"
      tmp__123 = a_8->array[1];
      # line 436 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__123->type_) {;
	# line 436 "../../../../Macaulay2/d/ffi.d"
	case 3:;
	# line 436 "../../../../Macaulay2/d/ffi.d"
	y_7 = ((gmp_ZZcell)tmp__123);
	# line 438 "../../../../Macaulay2/d/ffi.d"
	if ((!(gmp_isInt_1(y_7)))) goto L133_;
	# line 438 "../../../../Macaulay2/d/ffi.d"
	goto L134_;
	# line 438 "../../../../Macaulay2/d/ffi.d"
	L133_:;
	# line 438 "../../../../Macaulay2/d/ffi.d"
	tmp__124 = expr_WrongArgSmallInteger();
	# line 438 "../../../../Macaulay2/d/ffi.d"
	return tmp__124;
	# line 438 "../../../../Macaulay2/d/ffi.d"
	L134_:;
	# line 439 "../../../../Macaulay2/d/ffi.d"
	bits_5 = gmp_toInt_1(y_7);
	# line 440 "../../../../Macaulay2/d/ffi.d"
	if ((bits_5 == 0)) goto L135_;
	# line 442 "../../../../Macaulay2/d/ffi.d"
	if ((bits_5 == 32)) goto L136_;
	# line 444 "../../../../Macaulay2/d/ffi.d"
	if ((bits_5 == 64)) goto L137_;
	# line 446 "../../../../Macaulay2/d/ffi.d"
	tmp__125 = expr_buildErrorPacket(str__31);
	# line 446 "../../../../Macaulay2/d/ffi.d"
	goto L138_;
	# line 446 "../../../../Macaulay2/d/ffi.d"
	L137_:;
	# line 445 "../../../../Macaulay2/d/ffi.d"
	tmp__125 = util_toExpr_19(*(double *)x_8->v);
	# line 445 "../../../../Macaulay2/d/ffi.d"
	L138_:;
	# line 445 "../../../../Macaulay2/d/ffi.d"
	tmp__126 = tmp__125;
	# line 445 "../../../../Macaulay2/d/ffi.d"
	goto L139_;
	# line 445 "../../../../Macaulay2/d/ffi.d"
	L136_:;
	# line 443 "../../../../Macaulay2/d/ffi.d"
	tmp__126 = util_toExpr_18(*(float *)x_8->v);
	# line 443 "../../../../Macaulay2/d/ffi.d"
	L139_:;
	# line 443 "../../../../Macaulay2/d/ffi.d"
	tmp__127 = tmp__126;
	# line 443 "../../../../Macaulay2/d/ffi.d"
	goto L140_;
	# line 443 "../../../../Macaulay2/d/ffi.d"
	L135_:;
	# line 441 "../../../../Macaulay2/d/ffi.d"
	tmp__127 = util_toExpr_15(gmp_moveToRR(*(mpfr_ptr*)x_8->v));
	# line 441 "../../../../Macaulay2/d/ffi.d"
	L140_:;
	# line 441 "../../../../Macaulay2/d/ffi.d"
	tmp__128 = tmp__127;
	# line 441 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 441 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 447 "../../../../Macaulay2/d/ffi.d"
	tmp__128 = expr_WrongArgZZ_1(2);
	# line 447 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 447 "../../../../Macaulay2/d/ffi.d"
	};
      # line 447 "../../../../Macaulay2/d/ffi.d"
      tmp__129 = tmp__128;
      # line 447 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 447 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 448 "../../../../Macaulay2/d/ffi.d"
      tmp__129 = WrongArgPointer_1(1);
      # line 448 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 448 "../../../../Macaulay2/d/ffi.d"
      };
    # line 448 "../../../../Macaulay2/d/ffi.d"
    tmp__121 = tmp__129;
    # line 448 "../../../../Macaulay2/d/ffi.d"
    L132_:;
    # line 448 "../../../../Macaulay2/d/ffi.d"
    tmp__130 = tmp__121;
    # line 448 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 448 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 450 "../../../../Macaulay2/d/ffi.d"
    tmp__130 = expr_WrongNumArgs_1(2);
    # line 450 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 450 "../../../../Macaulay2/d/ffi.d"
    };
  # line 450 "../../../../Macaulay2/d/ffi.d"
  return tmp__130;
  # line 450 "../../../../Macaulay2/d/ffi.d"
  }
# line 450 "../../../../Macaulay2/d/ffi.d"
static M2_string str__32;
# line 450 "../../../../Macaulay2/d/ffi.d"
static M2_string str__33;
# line 450 "../../../../Macaulay2/d/ffi.d"
static M2_string str__34;
# line 450 "../../../../Macaulay2/d/ffi.d"
static M2_string str__35;
# line 450 "../../../../Macaulay2/d/ffi.d"
static M2_string str__36;
# line 460 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPointerAddress(parse_Expr e){
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_9;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  void * y_8;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  M2_stringCell x_10;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  void * y_9;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_9;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_11;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_List y_10;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  int n_5;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  int bytes;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  void * arr;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell z_7;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  void * ptr_5;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__131;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__132;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__133;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__134;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  int i_3;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  int tmp__135;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__136;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__137;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__138;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__139;
  # line 460 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 460 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 460 "../../../../Macaulay2/d/ffi.d"
    x_9 = ((parse_pointerCell)e);
    # line 462 "../../../../Macaulay2/d/ffi.d"
    y_8 = getMem(pointerSize);
    # line 463 "../../../../Macaulay2/d/ffi.d"
    *(void **)y_8 = x_9->v;
    # line 464 "../../../../Macaulay2/d/ffi.d"
    tmp__131 = toExpr_3(y_8);
    # line 464 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 464 "../../../../Macaulay2/d/ffi.d"
    case 19:;
    # line 460 "../../../../Macaulay2/d/ffi.d"
    x_10 = ((M2_stringCell)e);
    # line 466 "../../../../Macaulay2/d/ffi.d"
    y_9 = getMem(pointerSize);
    # line 467 "../../../../Macaulay2/d/ffi.d"
    *(void **)y_9 = M2_tocharstar(x_10->v);
    # line 468 "../../../../Macaulay2/d/ffi.d"
    tmp__131 = toExpr_3(y_9);
    # line 468 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 468 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 460 "../../../../Macaulay2/d/ffi.d"
    a_9 = ((parse_Sequence)e);
    # line 470 "../../../../Macaulay2/d/ffi.d"
    if ((a_9->len == 2)) goto L141_;
    # line 490 "../../../../Macaulay2/d/ffi.d"
    tmp__132 = expr_WrongNumArgs_3(1, 2);
    # line 490 "../../../../Macaulay2/d/ffi.d"
    goto L142_;
    # line 490 "../../../../Macaulay2/d/ffi.d"
    L141_:;
    # line 471 "../../../../Macaulay2/d/ffi.d"
    tmp__133 = a_9->array[0];
    # line 471 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__133->type_) {;
      # line 471 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 471 "../../../../Macaulay2/d/ffi.d"
      x_11 = ((parse_pointerCell)tmp__133);
      # line 473 "../../../../Macaulay2/d/ffi.d"
      tmp__134 = a_9->array[1];
      # line 473 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__134->type_) {;
	# line 473 "../../../../Macaulay2/d/ffi.d"
	case 46:;
	# line 473 "../../../../Macaulay2/d/ffi.d"
	y_10 = ((parse_List)tmp__134);
	# line 475 "../../../../Macaulay2/d/ffi.d"
	n_5 = y_10->v->len;
	# line 476 "../../../../Macaulay2/d/ffi.d"
	bytes = ((ffi_type *)x_11->v)->size;
	# line 477 "../../../../Macaulay2/d/ffi.d"
	arr = getMem((n_5 * bytes));
	# line 478 "../../../../Macaulay2/d/ffi.d"
	tmp__135 = (n_5 - 1);
	# line 478 "../../../../Macaulay2/d/ffi.d"
	i_3 = 0;
	# line 478 "../../../../Macaulay2/d/ffi.d"
	goto L145_;
	# line 478 "../../../../Macaulay2/d/ffi.d"
	L143_:;
	# line 478 "../../../../Macaulay2/d/ffi.d"
	i_3 = (i_3 + 1);
	# line 478 "../../../../Macaulay2/d/ffi.d"
	L145_:;
	# line 478 "../../../../Macaulay2/d/ffi.d"
	if ((((i_3 > tmp__135) && (1 >= 0)) || ((i_3 < tmp__135) && (1 < 0)))) goto L144_;
	# line 479 "../../../../Macaulay2/d/ffi.d"
	tmp__136 = y_10->v->array[i_3];
	# line 479 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__136->type_) {;
	  # line 479 "../../../../Macaulay2/d/ffi.d"
	  case 81:;
	  # line 479 "../../../../Macaulay2/d/ffi.d"
	  z_7 = ((parse_pointerCell)tmp__136);
	  # line 480 "../../../../Macaulay2/d/ffi.d"
	  memcpy(arr + (i_3 * bytes), z_7->v, bytes);
	  # line 482 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 482 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 483 "../../../../Macaulay2/d/ffi.d"
	  tmp__137 = expr_buildErrorPacket(str__34);
	  # line 483 "../../../../Macaulay2/d/ffi.d"
	  return tmp__137;
	  # line 483 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 483 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 483 "../../../../Macaulay2/d/ffi.d"
	goto L143_;
	# line 483 "../../../../Macaulay2/d/ffi.d"
	L144_:;
	# line 485 "../../../../Macaulay2/d/ffi.d"
	ptr_5 = getMem(pointerSize);
	# line 486 "../../../../Macaulay2/d/ffi.d"
	*(void **)ptr_5 = arr;
	# line 487 "../../../../Macaulay2/d/ffi.d"
	tmp__138 = toExpr_3(ptr_5);
	# line 487 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 487 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 488 "../../../../Macaulay2/d/ffi.d"
	tmp__138 = expr_WrongArg_1(2, str__35);
	# line 488 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 488 "../../../../Macaulay2/d/ffi.d"
	};
      # line 488 "../../../../Macaulay2/d/ffi.d"
      tmp__139 = tmp__138;
      # line 488 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 488 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 489 "../../../../Macaulay2/d/ffi.d"
      tmp__139 = WrongArgPointer_1(1);
      # line 489 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 489 "../../../../Macaulay2/d/ffi.d"
      };
    # line 489 "../../../../Macaulay2/d/ffi.d"
    tmp__132 = tmp__139;
    # line 489 "../../../../Macaulay2/d/ffi.d"
    L142_:;
    # line 489 "../../../../Macaulay2/d/ffi.d"
    tmp__131 = tmp__132;
    # line 489 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 489 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 491 "../../../../Macaulay2/d/ffi.d"
    tmp__131 = expr_WrongArg(str__36);
    # line 491 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 491 "../../../../Macaulay2/d/ffi.d"
    };
  # line 491 "../../../../Macaulay2/d/ffi.d"
  return tmp__131;
  # line 491 "../../../../Macaulay2/d/ffi.d"
  }
# line 491 "../../../../Macaulay2/d/ffi.d"
static M2_string str__37;
# line 495 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiPointerValue(parse_Expr e){
  # line 495 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_12;
  # line 495 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__140;
  # line 495 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 495 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 495 "../../../../Macaulay2/d/ffi.d"
    x_12 = ((parse_pointerCell)e);
    # line 496 "../../../../Macaulay2/d/ffi.d"
    tmp__140 = toExpr_3(*(void **)x_12->v);
    # line 496 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 496 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 497 "../../../../Macaulay2/d/ffi.d"
    tmp__140 = WrongArgPointer();
    # line 497 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 497 "../../../../Macaulay2/d/ffi.d"
    };
  # line 497 "../../../../Macaulay2/d/ffi.d"
  return tmp__140;
  # line 497 "../../../../Macaulay2/d/ffi.d"
  }
# line 497 "../../../../Macaulay2/d/ffi.d"
static M2_string str__38;
# line 501 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiStringValue(parse_Expr e){
  # line 501 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_13;
  # line 501 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__141;
  # line 501 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 501 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 501 "../../../../Macaulay2/d/ffi.d"
    x_13 = ((parse_pointerCell)e);
    # line 502 "../../../../Macaulay2/d/ffi.d"
    tmp__141 = util_toExpr_12(M2_tostring_2(*(char **)x_13->v));
    # line 502 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 502 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 503 "../../../../Macaulay2/d/ffi.d"
    tmp__141 = WrongArgPointer();
    # line 503 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 503 "../../../../Macaulay2/d/ffi.d"
    };
  # line 503 "../../../../Macaulay2/d/ffi.d"
  return tmp__141;
  # line 503 "../../../../Macaulay2/d/ffi.d"
  }
# line 503 "../../../../Macaulay2/d/ffi.d"
static M2_string str__39;
# line 507 "../../../../Macaulay2/d/ffi.d"
static void ptrfinalizer(void * x,parse_Sequence a){
  # line 507 "../../../../Macaulay2/d/ffi.d"
  if ((a->len == 2)) goto L146_;
  # line 507 "../../../../Macaulay2/d/ffi.d"
  goto L147_;
  # line 507 "../../../../Macaulay2/d/ffi.d"
  L146_:;
  # line 508 "../../../../Macaulay2/d/ffi.d"
  evaluate_applyEE(a->array[0], a->array[1]);
  # line 508 "../../../../Macaulay2/d/ffi.d"
  L147_:;
  # line 508 "../../../../Macaulay2/d/ffi.d"
  }
# line 513 "../../../../Macaulay2/d/ffi.d"
static parse_Expr registerFinalizerForPointer(parse_Expr e){
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence s_1;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_14;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  int i_4;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_10;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__142;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__143;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence tmp__144;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  int tmp__145;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__146;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__147;
  # line 513 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 513 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 513 "../../../../Macaulay2/d/ffi.d"
    s_1 = ((parse_Sequence)e);
    # line 514 "../../../../Macaulay2/d/ffi.d"
    if ((s_1->len == 3)) goto L148_;
    # line 522 "../../../../Macaulay2/d/ffi.d"
    tmp__142 = expr_WrongNumArgs_1(3);
    # line 522 "../../../../Macaulay2/d/ffi.d"
    goto L149_;
    # line 522 "../../../../Macaulay2/d/ffi.d"
    L148_:;
    # line 515 "../../../../Macaulay2/d/ffi.d"
    tmp__143 = s_1->array[0];
    # line 515 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__143->type_) {;
      # line 515 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 515 "../../../../Macaulay2/d/ffi.d"
      x_14 = ((parse_pointerCell)tmp__143);
      # line 515 "../../../../Macaulay2/d/ffi.d"
      i_4 = 0;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      tmp__145 = 2;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      ;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      tmp__144 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (tmp__145)*sizeof(parse_Expr)-sizeof(parse_Expr));
      if (0 == tmp__144) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (tmp__145)*sizeof(parse_Expr)-sizeof(parse_Expr));
      # line 517 "../../../../Macaulay2/d/ffi.d"
      tmp__144->type_ = 7;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      tmp__144->len = tmp__145;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      if ((tmp__145 == 0)) goto L151_;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      L150_:;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      tmp__144->array[i_4] = s_1->array[(i_4 + 1)];
      # line 517 "../../../../Macaulay2/d/ffi.d"
      if (((++ i_4) < tmp__145)) goto L152_;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      goto L151_;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      L152_:;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      goto L150_;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      L151_:;
      # line 517 "../../../../Macaulay2/d/ffi.d"
      a_10 = tmp__144;
      # line 518 "../../../../Macaulay2/d/ffi.d"
      GC_REGISTER_FINALIZER(x_14->v, (GC_finalization_proc)ptrfinalizer, a_10, 0, 0);
      # line 520 "../../../../Macaulay2/d/ffi.d"
      tmp__146 = parse_nullE;
      # line 520 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 520 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 521 "../../../../Macaulay2/d/ffi.d"
      tmp__146 = WrongArgPointer_1(1);
      # line 521 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 521 "../../../../Macaulay2/d/ffi.d"
      };
    # line 521 "../../../../Macaulay2/d/ffi.d"
    tmp__142 = tmp__146;
    # line 521 "../../../../Macaulay2/d/ffi.d"
    L149_:;
    # line 521 "../../../../Macaulay2/d/ffi.d"
    tmp__147 = tmp__142;
    # line 521 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 521 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 523 "../../../../Macaulay2/d/ffi.d"
    tmp__147 = expr_WrongNumArgs_1(3);
    # line 523 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 523 "../../../../Macaulay2/d/ffi.d"
    };
  # line 523 "../../../../Macaulay2/d/ffi.d"
  return tmp__147;
  # line 523 "../../../../Macaulay2/d/ffi.d"
  }
# line 523 "../../../../Macaulay2/d/ffi.d"
static M2_string str__40;
# line 523 "../../../../Macaulay2/d/ffi.d"
static M2_string str__41;
# line 531 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiStructType(parse_Expr e){
  # line 531 "../../../../Macaulay2/d/ffi.d"
  parse_List a_11;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  void * x_15;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  int n_6;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  int i_5;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell p_1;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * elmnts;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__148;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  int tmp__149;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  void * tmp__150;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__151;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  void * tmp__152;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__153;
  # line 531 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 531 "../../../../Macaulay2/d/ffi.d"
    case 46:;
    # line 531 "../../../../Macaulay2/d/ffi.d"
    a_11 = ((parse_List)e);
    # line 533 "../../../../Macaulay2/d/ffi.d"
    x_15 = getMem(sizeof(ffi_type));
    # line 534 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->size = 0;
    # line 535 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->alignment = 0;
    # line 536 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->type = FFI_TYPE_STRUCT;
    # line 537 "../../../../Macaulay2/d/ffi.d"
    n_6 = a_11->v->len;
    # line 537 "../../../../Macaulay2/d/ffi.d"
    i_5 = 0;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    tmp__149 = (n_6 + 1);
    # line 538 "../../../../Macaulay2/d/ffi.d"
    ;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    tmp__148 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__149)*sizeof(void *)-sizeof(void *));
    if (0 == tmp__148) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__149)*sizeof(void *)-sizeof(void *));
    # line 538 "../../../../Macaulay2/d/ffi.d"
    tmp__148->len = tmp__149;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    if ((tmp__149 == 0)) goto L154_;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    L153_:;
    # line 539 "../../../../Macaulay2/d/ffi.d"
    if ((i_5 < n_6)) goto L155_;
    # line 543 "../../../../Macaulay2/d/ffi.d"
    tmp__150 = ((void *)0);
    # line 543 "../../../../Macaulay2/d/ffi.d"
    goto L156_;
    # line 543 "../../../../Macaulay2/d/ffi.d"
    L155_:;
    # line 540 "../../../../Macaulay2/d/ffi.d"
    tmp__151 = a_11->v->array[i_5];
    # line 540 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__151->type_) {;
      # line 540 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 540 "../../../../Macaulay2/d/ffi.d"
      p_1 = ((parse_pointerCell)tmp__151);
      # line 541 "../../../../Macaulay2/d/ffi.d"
      tmp__152 = p_1->v;
      # line 541 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 541 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 542 "../../../../Macaulay2/d/ffi.d"
      tmp__152 = ((void *)0);
      # line 542 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 542 "../../../../Macaulay2/d/ffi.d"
      };
    # line 542 "../../../../Macaulay2/d/ffi.d"
    tmp__150 = tmp__152;
    # line 542 "../../../../Macaulay2/d/ffi.d"
    L156_:;
    # line 542 "../../../../Macaulay2/d/ffi.d"
    tmp__148->array[i_5] = tmp__150;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    if (((++ i_5) < tmp__149)) goto L157_;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    goto L154_;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    L157_:;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    goto L153_;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    L154_:;
    # line 538 "../../../../Macaulay2/d/ffi.d"
    elmnts = tmp__148;
    # line 544 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_15)->elements = (ffi_type **)elmnts->array;
    # line 546 "../../../../Macaulay2/d/ffi.d"
    tmp__153 = toExpr_3(x_15);
    # line 546 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 546 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 547 "../../../../Macaulay2/d/ffi.d"
    tmp__153 = expr_WrongArg(str__41);
    # line 547 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 547 "../../../../Macaulay2/d/ffi.d"
    };
  # line 547 "../../../../Macaulay2/d/ffi.d"
  return tmp__153;
  # line 547 "../../../../Macaulay2/d/ffi.d"
  }
# line 547 "../../../../Macaulay2/d/ffi.d"
static M2_string str__42;
# line 551 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiGetStructOffsets(parse_Expr e){
  # line 551 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_16;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  int n_7;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  void * offsets;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  int r_5;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  int i_6;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__154;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence tmp__155;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  int tmp__156;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__157;
  # line 551 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 551 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 551 "../../../../Macaulay2/d/ffi.d"
    x_16 = ((parse_pointerCell)e);
    # line 553 "../../../../Macaulay2/d/ffi.d"
    n_7 = 0;
    # line 553 "../../../../Macaulay2/d/ffi.d"
    L158_:;
    # line 554 "../../../../Macaulay2/d/ffi.d"
    if ((! ((((ffi_type *)x_16->v)->elements)[n_7] != ((void *)0)))) goto L159_;
    # line 555 "../../../../Macaulay2/d/ffi.d"
    n_7 = (n_7 + 1);
    # line 555 "../../../../Macaulay2/d/ffi.d"
    goto L158_;
    # line 555 "../../../../Macaulay2/d/ffi.d"
    L159_:;
    # line 556 "../../../../Macaulay2/d/ffi.d"
    offsets = getmem((n_7) * sizeof(size_t));
    # line 557 "../../../../Macaulay2/d/ffi.d"
    r_5 = ffi_get_struct_offsets(FFI_DEFAULT_ABI, (ffi_type *)x_16->v, (size_t *)offsets);
    # line 559 "../../../../Macaulay2/d/ffi.d"
    if ((r_5 != ffiOk)) goto L161_;
    # line 559 "../../../../Macaulay2/d/ffi.d"
    goto L162_;
    # line 559 "../../../../Macaulay2/d/ffi.d"
    L161_:;
    # line 559 "../../../../Macaulay2/d/ffi.d"
    tmp__154 = ffiError(r_5);
    # line 559 "../../../../Macaulay2/d/ffi.d"
    return tmp__154;
    # line 559 "../../../../Macaulay2/d/ffi.d"
    L162_:;
    # line 559 "../../../../Macaulay2/d/ffi.d"
    i_6 = 0;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    tmp__156 = n_7;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    ;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    tmp__155 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (tmp__156)*sizeof(parse_Expr)-sizeof(parse_Expr));
    if (0 == tmp__155) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (tmp__156)*sizeof(parse_Expr)-sizeof(parse_Expr));
    # line 560 "../../../../Macaulay2/d/ffi.d"
    tmp__155->type_ = 7;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    tmp__155->len = tmp__156;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    if ((tmp__156 == 0)) goto L164_;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    L163_:;
    # line 561 "../../../../Macaulay2/d/ffi.d"
    tmp__155->array[i_6] = util_toExpr(((size_t *)offsets)[i_6]);
    # line 560 "../../../../Macaulay2/d/ffi.d"
    if (((++ i_6) < tmp__156)) goto L165_;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    goto L164_;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    L165_:;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    goto L163_;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    L164_:;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    tmp__157 = basic_list(tmp__155);
    # line 560 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 560 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 562 "../../../../Macaulay2/d/ffi.d"
    tmp__157 = WrongArgPointer();
    # line 562 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 562 "../../../../Macaulay2/d/ffi.d"
    };
  # line 562 "../../../../Macaulay2/d/ffi.d"
  return tmp__157;
  # line 562 "../../../../Macaulay2/d/ffi.d"
  }
# line 562 "../../../../Macaulay2/d/ffi.d"
static M2_string str__43;
# line 562 "../../../../Macaulay2/d/ffi.d"
static M2_string str__44;
# line 566 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiStructAddress(parse_Expr e){
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_12;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell x_17;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_List y_11;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  int n_8;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  void * offsets_1;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  int r_6;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  void * result;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell elmnt;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  int tocopy;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__158;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__159;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__160;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__161;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  int i_7;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  int tmp__162;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__163;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__164;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__165;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__166;
  # line 566 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 566 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 566 "../../../../Macaulay2/d/ffi.d"
    a_12 = ((parse_Sequence)e);
    # line 568 "../../../../Macaulay2/d/ffi.d"
    if ((a_12->len == 2)) goto L166_;
    # line 594 "../../../../Macaulay2/d/ffi.d"
    tmp__158 = expr_WrongNumArgs_1(2);
    # line 594 "../../../../Macaulay2/d/ffi.d"
    goto L167_;
    # line 594 "../../../../Macaulay2/d/ffi.d"
    L166_:;
    # line 569 "../../../../Macaulay2/d/ffi.d"
    tmp__159 = a_12->array[0];
    # line 569 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__159->type_) {;
      # line 569 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 569 "../../../../Macaulay2/d/ffi.d"
      x_17 = ((parse_pointerCell)tmp__159);
      # line 571 "../../../../Macaulay2/d/ffi.d"
      tmp__160 = a_12->array[1];
      # line 571 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__160->type_) {;
	# line 571 "../../../../Macaulay2/d/ffi.d"
	case 46:;
	# line 571 "../../../../Macaulay2/d/ffi.d"
	y_11 = ((parse_List)tmp__160);
	# line 572 "../../../../Macaulay2/d/ffi.d"
	n_8 = 0;
	# line 572 "../../../../Macaulay2/d/ffi.d"
	L168_:;
	# line 573 "../../../../Macaulay2/d/ffi.d"
	if ((! ((((ffi_type *)x_17->v)->elements)[n_8] != ((void *)0)))) goto L169_;
	# line 574 "../../../../Macaulay2/d/ffi.d"
	n_8 = (n_8 + 1);
	# line 574 "../../../../Macaulay2/d/ffi.d"
	goto L168_;
	# line 574 "../../../../Macaulay2/d/ffi.d"
	L169_:;
	# line 575 "../../../../Macaulay2/d/ffi.d"
	offsets_1 = getmem((n_8) * sizeof(size_t));
	# line 577 "../../../../Macaulay2/d/ffi.d"
	r_6 = ffi_get_struct_offsets(FFI_DEFAULT_ABI, (ffi_type *)x_17->v, (size_t *)offsets_1);
	# line 579 "../../../../Macaulay2/d/ffi.d"
	if ((r_6 != ffiOk)) goto L171_;
	# line 579 "../../../../Macaulay2/d/ffi.d"
	goto L172_;
	# line 579 "../../../../Macaulay2/d/ffi.d"
	L171_:;
	# line 579 "../../../../Macaulay2/d/ffi.d"
	tmp__161 = ffiError(r_6);
	# line 579 "../../../../Macaulay2/d/ffi.d"
	return tmp__161;
	# line 579 "../../../../Macaulay2/d/ffi.d"
	L172_:;
	# line 580 "../../../../Macaulay2/d/ffi.d"
	result = getMem(((ffi_type *)x_17->v)->size);
	# line 582 "../../../../Macaulay2/d/ffi.d"
	tmp__162 = (n_8 - 1);
	# line 582 "../../../../Macaulay2/d/ffi.d"
	i_7 = 0;
	# line 582 "../../../../Macaulay2/d/ffi.d"
	goto L175_;
	# line 582 "../../../../Macaulay2/d/ffi.d"
	L173_:;
	# line 582 "../../../../Macaulay2/d/ffi.d"
	i_7 = (i_7 + 1);
	# line 582 "../../../../Macaulay2/d/ffi.d"
	L175_:;
	# line 582 "../../../../Macaulay2/d/ffi.d"
	if ((((i_7 > tmp__162) && (1 >= 0)) || ((i_7 < tmp__162) && (1 < 0)))) goto L174_;
	# line 583 "../../../../Macaulay2/d/ffi.d"
	tmp__163 = y_11->v->array[i_7];
	# line 583 "../../../../Macaulay2/d/ffi.d"
	switch (tmp__163->type_) {;
	  # line 583 "../../../../Macaulay2/d/ffi.d"
	  case 81:;
	  # line 583 "../../../../Macaulay2/d/ffi.d"
	  elmnt = ((parse_pointerCell)tmp__163);
	  # line 585 "../../../../Macaulay2/d/ffi.d"
	  tocopy = (((ffi_type *)x_17->v)->elements)[i_7]->size;
	  # line 587 "../../../../Macaulay2/d/ffi.d"
	  memcpy(result + ((size_t *)offsets_1)[i_7],elmnt->v, tocopy);
	  # line 588 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 588 "../../../../Macaulay2/d/ffi.d"
	  default:;
	  # line 588 "../../../../Macaulay2/d/ffi.d"
	  break;
	  # line 588 "../../../../Macaulay2/d/ffi.d"
	  };
	# line 588 "../../../../Macaulay2/d/ffi.d"
	goto L173_;
	# line 588 "../../../../Macaulay2/d/ffi.d"
	L174_:;
	# line 591 "../../../../Macaulay2/d/ffi.d"
	tmp__164 = toExpr_3(result);
	# line 591 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 591 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 592 "../../../../Macaulay2/d/ffi.d"
	tmp__164 = expr_WrongArg_1(2, str__44);
	# line 592 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 592 "../../../../Macaulay2/d/ffi.d"
	};
      # line 592 "../../../../Macaulay2/d/ffi.d"
      tmp__165 = tmp__164;
      # line 592 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 592 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 593 "../../../../Macaulay2/d/ffi.d"
      tmp__165 = WrongArgPointer_1(1);
      # line 593 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 593 "../../../../Macaulay2/d/ffi.d"
      };
    # line 593 "../../../../Macaulay2/d/ffi.d"
    tmp__158 = tmp__165;
    # line 593 "../../../../Macaulay2/d/ffi.d"
    L167_:;
    # line 593 "../../../../Macaulay2/d/ffi.d"
    tmp__166 = tmp__158;
    # line 593 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 593 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 595 "../../../../Macaulay2/d/ffi.d"
    tmp__166 = expr_WrongNumArgs_1(2);
    # line 595 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 595 "../../../../Macaulay2/d/ffi.d"
    };
  # line 595 "../../../../Macaulay2/d/ffi.d"
  return tmp__166;
  # line 595 "../../../../Macaulay2/d/ffi.d"
  }
# line 595 "../../../../Macaulay2/d/ffi.d"
static M2_string str__45;
# line 595 "../../../../Macaulay2/d/ffi.d"
static M2_string str__46;
# line 604 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiUnionType(parse_Expr e){
  # line 604 "../../../../Macaulay2/d/ffi.d"
  parse_List a_13;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  void * x_18;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * elmnts_1;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  void * cif_3;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell p_2;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  int tmp__167;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  struct M2_1129 * tmp__168;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  int tmp__169;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  int i_8;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  int tmp__170;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__171;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__172;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__173;
  # line 604 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 604 "../../../../Macaulay2/d/ffi.d"
    case 46:;
    # line 604 "../../../../Macaulay2/d/ffi.d"
    a_13 = ((parse_List)e);
    # line 607 "../../../../Macaulay2/d/ffi.d"
    x_18 = getMem(sizeof(ffi_type));
    # line 608 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->size = 0;
    # line 609 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->alignment = 0;
    # line 610 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->type = FFI_TYPE_STRUCT;
    # line 610 "../../../../Macaulay2/d/ffi.d"
    tmp__167 = 0;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    tmp__169 = 2;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    ;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    tmp__168 = (struct M2_1129 *) GC_MALLOC(sizeof(struct M2_1129) + (tmp__169)*sizeof(void *)-sizeof(void *));
    if (0 == tmp__168) outofmem2((size_t)sizeof(struct M2_1129) + (tmp__169)*sizeof(void *)-sizeof(void *));
    # line 611 "../../../../Macaulay2/d/ffi.d"
    tmp__168->len = tmp__169;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    if ((tmp__169 == 0)) goto L177_;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    L176_:;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    tmp__168->array[tmp__167] = ((void *)0);
    # line 611 "../../../../Macaulay2/d/ffi.d"
    if (((++ tmp__167) < tmp__169)) goto L178_;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    goto L177_;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    L178_:;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    goto L176_;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    L177_:;
    # line 611 "../../../../Macaulay2/d/ffi.d"
    elmnts_1 = tmp__168;
    # line 612 "../../../../Macaulay2/d/ffi.d"
    ((ffi_type *)x_18)->elements = (ffi_type **)elmnts_1->array;
    # line 614 "../../../../Macaulay2/d/ffi.d"
    cif_3 = getMem(sizeof(ffi_cif));
    # line 615 "../../../../Macaulay2/d/ffi.d"
    tmp__170 = (a_13->v->len - 1);
    # line 615 "../../../../Macaulay2/d/ffi.d"
    i_8 = 0;
    # line 615 "../../../../Macaulay2/d/ffi.d"
    goto L181_;
    # line 615 "../../../../Macaulay2/d/ffi.d"
    L179_:;
    # line 615 "../../../../Macaulay2/d/ffi.d"
    i_8 = (i_8 + 1);
    # line 615 "../../../../Macaulay2/d/ffi.d"
    L181_:;
    # line 615 "../../../../Macaulay2/d/ffi.d"
    if ((((i_8 > tmp__170) && (1 >= 0)) || ((i_8 < tmp__170) && (1 < 0)))) goto L180_;
    # line 616 "../../../../Macaulay2/d/ffi.d"
    tmp__171 = a_13->v->array[i_8];
    # line 616 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__171->type_) {;
      # line 616 "../../../../Macaulay2/d/ffi.d"
      case 81:;
      # line 616 "../../../../Macaulay2/d/ffi.d"
      p_2 = ((parse_pointerCell)tmp__171);
      # line 618 "../../../../Macaulay2/d/ffi.d"
      if ((ffi_prep_cif((ffi_cif *)cif_3, FFI_DEFAULT_ABI, 0, p_2->v, NULL) == ffiOk)) goto L182_;
      # line 619 "../../../../Macaulay2/d/ffi.d"
      goto L183_;
      # line 619 "../../../../Macaulay2/d/ffi.d"
      L182_:;
      # line 621 "../../../../Macaulay2/d/ffi.d"
      if ((((ffi_type *)p_2->v)->size > ((ffi_type *)x_18)->size)) goto L184_;
      # line 620 "../../../../Macaulay2/d/ffi.d"
      goto L185_;
      # line 620 "../../../../Macaulay2/d/ffi.d"
      L184_:;
      # line 622 "../../../../Macaulay2/d/ffi.d"
      ((ffi_type *)x_18)->size = ((ffi_type *)p_2->v)->size;
      # line 623 "../../../../Macaulay2/d/ffi.d"
      L185_:;
      # line 625 "../../../../Macaulay2/d/ffi.d"
      if ((((ffi_type *)p_2->v)->alignment > ((ffi_type *)x_18)->alignment)) goto L186_;
      # line 624 "../../../../Macaulay2/d/ffi.d"
      goto L187_;
      # line 624 "../../../../Macaulay2/d/ffi.d"
      L186_:;
      # line 626 "../../../../Macaulay2/d/ffi.d"
      ((ffi_type *)x_18)->alignment = ((ffi_type *)p_2->v)->alignment;
      # line 627 "../../../../Macaulay2/d/ffi.d"
      L187_:;
      # line 627 "../../../../Macaulay2/d/ffi.d"
      L183_:;
      # line 627 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 627 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 629 "../../../../Macaulay2/d/ffi.d"
      tmp__172 = WrongArgPointer_1((i_8 + 1));
      # line 629 "../../../../Macaulay2/d/ffi.d"
      return tmp__172;
      # line 629 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 629 "../../../../Macaulay2/d/ffi.d"
      };
    # line 629 "../../../../Macaulay2/d/ffi.d"
    goto L179_;
    # line 629 "../../../../Macaulay2/d/ffi.d"
    L180_:;
    # line 630 "../../../../Macaulay2/d/ffi.d"
    tmp__173 = toExpr_3(x_18);
    # line 630 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 630 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 631 "../../../../Macaulay2/d/ffi.d"
    tmp__173 = expr_WrongArg(str__46);
    # line 631 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 631 "../../../../Macaulay2/d/ffi.d"
    };
  # line 631 "../../../../Macaulay2/d/ffi.d"
  return tmp__173;
  # line 631 "../../../../Macaulay2/d/ffi.d"
  }
# line 631 "../../../../Macaulay2/d/ffi.d"
static M2_string str__47;
# line 640 "../../../../Macaulay2/d/ffi.d"
static void ffiClosureFunction(ffi_cif * cif,void * ret,void ** args,void * userData){
  # line 640 "../../../../Macaulay2/d/ffi.d"
  int nargs;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_Expr f;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  int i_9;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_Expr x_19;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell ptr_6;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_Error err_1;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence tmp__174;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  int tmp__175;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell tmp__176;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__177;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell tmp__178;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__179;
  # line 640 "../../../../Macaulay2/d/ffi.d"
  nargs = cif->nargs;
  # line 641 "../../../../Macaulay2/d/ffi.d"
  f = ((parse_Expr)userData);
  # line 643 "../../../../Macaulay2/d/ffi.d"
  if ((nargs == 1)) goto L188_;
  # line 643 "../../../../Macaulay2/d/ffi.d"
  i_9 = 0;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__175 = nargs;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  ;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__174 = (parse_Sequence) GC_MALLOC(sizeof(struct parse_Sequence_struct) + (tmp__175)*sizeof(parse_Expr)-sizeof(parse_Expr));
  if (0 == tmp__174) outofmem2((size_t)sizeof(struct parse_Sequence_struct) + (tmp__175)*sizeof(parse_Expr)-sizeof(parse_Expr));
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__174->type_ = 7;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__174->len = tmp__175;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  if ((tmp__175 == 0)) goto L190_;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  L189_:;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__176 = (parse_pointerCell) GC_MALLOC(sizeof(struct parse_pointerCell_struct));
  if (0 == tmp__176) outofmem2((size_t)sizeof(struct parse_pointerCell_struct));
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__176->type_ = 81;
  # line 645 "../../../../Macaulay2/d/ffi.d"
  tmp__176->v = args[i_9];
  # line 645 "../../../../Macaulay2/d/ffi.d"
  tmp__174->array[i_9] = ((parse_Expr)tmp__176);
  # line 644 "../../../../Macaulay2/d/ffi.d"
  if (((++ i_9) < tmp__175)) goto L191_;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  goto L190_;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  L191_:;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  goto L189_;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  L190_:;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__177 = ((parse_Expr)tmp__174);
  # line 644 "../../../../Macaulay2/d/ffi.d"
  goto L192_;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  L188_:;
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__178 = (parse_pointerCell) GC_MALLOC(sizeof(struct parse_pointerCell_struct));
  if (0 == tmp__178) outofmem2((size_t)sizeof(struct parse_pointerCell_struct));
  # line 644 "../../../../Macaulay2/d/ffi.d"
  tmp__178->type_ = 81;
  # line 643 "../../../../Macaulay2/d/ffi.d"
  tmp__178->v = *args;
  # line 643 "../../../../Macaulay2/d/ffi.d"
  tmp__177 = ((parse_Expr)tmp__178);
  # line 643 "../../../../Macaulay2/d/ffi.d"
  L192_:;
  # line 643 "../../../../Macaulay2/d/ffi.d"
  x_19 = tmp__177;
  # line 646 "../../../../Macaulay2/d/ffi.d"
  tmp__179 = evaluate_applyEE(f, x_19);
  # line 646 "../../../../Macaulay2/d/ffi.d"
  switch (tmp__179->type_) {;
    # line 646 "../../../../Macaulay2/d/ffi.d"
    case 81:;
    # line 646 "../../../../Macaulay2/d/ffi.d"
    ptr_6 = ((parse_pointerCell)tmp__179);
    # line 648 "../../../../Macaulay2/d/ffi.d"
    memcpy(endianAdjust(ret, ((ffi_cif *)cif)->rtype), ptr_6->v, cif->rtype->size);
    # line 650 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 650 "../../../../Macaulay2/d/ffi.d"
    case 16:;
    # line 650 "../../../../Macaulay2/d/ffi.d"
    err_1 = ((parse_Error)tmp__179);
    # line 651 "../../../../Macaulay2/d/ffi.d"
    tokens_printErrorMessage(err_1);
    # line 651 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 651 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 651 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 651 "../../../../Macaulay2/d/ffi.d"
    };
  # line 651 "../../../../Macaulay2/d/ffi.d"
  }
# line 655 "../../../../Macaulay2/d/ffi.d"
static void ffiClosureFinalizer(void * ptr,void * closure){
  # line 655 "../../../../Macaulay2/d/ffi.d"
  ffi_closure_free(closure);
  # line 655 "../../../../Macaulay2/d/ffi.d"
  }
# line 655 "../../../../Macaulay2/d/ffi.d"
static M2_string str__48;
# line 655 "../../../../Macaulay2/d/ffi.d"
static M2_string str__49;
# line 658 "../../../../Macaulay2/d/ffi.d"
static parse_Expr ffiFunctionPointerAddress(parse_Expr e){
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Sequence a_14;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_FunctionClosure f_1;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_pointerCell cif_4;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  void * code;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  void * closure_1;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  int r_7;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  void * ptr_7;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__180;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__181;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__182;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__183;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__184;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__185;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  parse_Expr tmp__186;
  # line 658 "../../../../Macaulay2/d/ffi.d"
  switch (e->type_) {;
    # line 658 "../../../../Macaulay2/d/ffi.d"
    case 7:;
    # line 658 "../../../../Macaulay2/d/ffi.d"
    a_14 = ((parse_Sequence)e);
    # line 660 "../../../../Macaulay2/d/ffi.d"
    tmp__180 = a_14->array[0];
    # line 660 "../../../../Macaulay2/d/ffi.d"
    switch (tmp__180->type_) {;
      # line 660 "../../../../Macaulay2/d/ffi.d"
      case 55:;
      # line 660 "../../../../Macaulay2/d/ffi.d"
      f_1 = ((parse_FunctionClosure)tmp__180);
      # line 662 "../../../../Macaulay2/d/ffi.d"
      tmp__181 = a_14->array[1];
      # line 662 "../../../../Macaulay2/d/ffi.d"
      switch (tmp__181->type_) {;
	# line 662 "../../../../Macaulay2/d/ffi.d"
	case 81:;
	# line 662 "../../../../Macaulay2/d/ffi.d"
	cif_4 = ((parse_pointerCell)tmp__181);
	# line 664 "../../../../Macaulay2/d/ffi.d"
	code = ((void *)0);
	# line 665 "../../../../Macaulay2/d/ffi.d"
	closure_1 = ffi_closure_alloc(sizeof(ffi_closure), &code);
	# line 667 "../../../../Macaulay2/d/ffi.d"
	if ((closure_1 == ((void *)0))) goto L193_;
	# line 667 "../../../../Macaulay2/d/ffi.d"
	goto L194_;
	# line 667 "../../../../Macaulay2/d/ffi.d"
	L193_:;
	# line 667 "../../../../Macaulay2/d/ffi.d"
	tmp__182 = expr_buildErrorPacket(str__48);
	# line 667 "../../../../Macaulay2/d/ffi.d"
	return tmp__182;
	# line 667 "../../../../Macaulay2/d/ffi.d"
	L194_:;
	# line 669 "../../../../Macaulay2/d/ffi.d"
	r_7 = ffi_prep_closure_loc(closure_1, cif_4->v, ffiClosureFunction, f_1, code);
	# line 671 "../../../../Macaulay2/d/ffi.d"
	if ((r_7 != ffiOk)) goto L195_;
	# line 671 "../../../../Macaulay2/d/ffi.d"
	goto L196_;
	# line 671 "../../../../Macaulay2/d/ffi.d"
	L195_:;
	# line 671 "../../../../Macaulay2/d/ffi.d"
	tmp__183 = ffiError(r_7);
	# line 671 "../../../../Macaulay2/d/ffi.d"
	return tmp__183;
	# line 671 "../../../../Macaulay2/d/ffi.d"
	L196_:;
	# line 672 "../../../../Macaulay2/d/ffi.d"
	ptr_7 = getMem(pointerSize);
	# line 673 "../../../../Macaulay2/d/ffi.d"
	*(void **)ptr_7 = closure_1;
	# line 674 "../../../../Macaulay2/d/ffi.d"
	GC_REGISTER_FINALIZER(ptr_7, (GC_finalization_proc)ffiClosureFinalizer, closure_1, 0, 0);
	# line 677 "../../../../Macaulay2/d/ffi.d"
	tmp__184 = toExpr_3(ptr_7);
	# line 677 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 677 "../../../../Macaulay2/d/ffi.d"
	default:;
	# line 678 "../../../../Macaulay2/d/ffi.d"
	tmp__184 = WrongArgPointer_1(2);
	# line 678 "../../../../Macaulay2/d/ffi.d"
	break;
	# line 678 "../../../../Macaulay2/d/ffi.d"
	};
      # line 678 "../../../../Macaulay2/d/ffi.d"
      tmp__185 = tmp__184;
      # line 678 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 678 "../../../../Macaulay2/d/ffi.d"
      default:;
      # line 679 "../../../../Macaulay2/d/ffi.d"
      tmp__185 = expr_WrongArg_1(1, str__49);
      # line 679 "../../../../Macaulay2/d/ffi.d"
      break;
      # line 679 "../../../../Macaulay2/d/ffi.d"
      };
    # line 679 "../../../../Macaulay2/d/ffi.d"
    tmp__186 = tmp__185;
    # line 679 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 679 "../../../../Macaulay2/d/ffi.d"
    default:;
    # line 680 "../../../../Macaulay2/d/ffi.d"
    tmp__186 = expr_WrongNumArgs_1(2);
    # line 680 "../../../../Macaulay2/d/ffi.d"
    break;
    # line 680 "../../../../Macaulay2/d/ffi.d"
    };
  # line 680 "../../../../Macaulay2/d/ffi.d"
  return tmp__186;
  # line 680 "../../../../Macaulay2/d/ffi.d"
  }
# line 680 "../../../../Macaulay2/d/ffi.d"
static M2_string str__50;
# line 680 "../../../../Macaulay2/d/ffi.d"
static void ffi__thread_prepare();
# line 680 "../../../../Macaulay2/d/ffi.d"
static void ffi__final();
# line 49 "../../../../Macaulay2/d/ffi.d"
void ffi__prepare(){
  # line 49 "../../../../Macaulay2/d/ffi.d"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  static int called_yet = 0;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  if (called_yet) return; else called_yet = 1;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str_ = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  if (0 == str_) outofmem2((size_t)sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str_->len = 9;
  # line 49 "../../../../Macaulay2/d/ffi.d"
  memcpy(str_->array, "a pointer", 9);
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str__1 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__1) outofmem2((size_t)sizeof(struct M2_string_struct) + (9)*sizeof(signed char)-sizeof(signed char));
  # line 49 "../../../../Macaulay2/d/ffi.d"
  str__1->len = 9;
  # line 50 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__1->array, "a pointer", 9);
  # line 50 "../../../../Macaulay2/d/ffi.d"
  str__2 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__2) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 50 "../../../../Macaulay2/d/ffi.d"
  str__2->len = 11;
  # line 51 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__2->array, "nullPointer", 11);
  # line 51 "../../../../Macaulay2/d/ffi.d"
  str__3 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__3) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 51 "../../../../Macaulay2/d/ffi.d"
  str__3->len = 6;
  # line 68 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__3->array, "dlopen", 6);
  # line 68 "../../../../Macaulay2/d/ffi.d"
  str__4 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (34)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__4) outofmem2((size_t)sizeof(struct M2_string_struct) + (34)*sizeof(signed char)-sizeof(signed char));
  # line 68 "../../../../Macaulay2/d/ffi.d"
  str__4->len = 34;
  # line 90 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__4->array, "a string or a pointer and a string", 34);
  # line 90 "../../../../Macaulay2/d/ffi.d"
  str__5 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__5) outofmem2((size_t)sizeof(struct M2_string_struct) + (5)*sizeof(signed char)-sizeof(signed char));
  # line 90 "../../../../Macaulay2/d/ffi.d"
  str__5->len = 5;
  # line 91 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__5->array, "dlsym", 5);
  # line 91 "../../../../Macaulay2/d/ffi.d"
  str__6 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__6) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 91 "../../../../Macaulay2/d/ffi.d"
  str__6->len = 11;
  # line 100 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__6->array, "ffiTypeSize", 11);
  # line 100 "../../../../Macaulay2/d/ffi.d"
  str__7 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__7) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 100 "../../../../Macaulay2/d/ffi.d"
  str__7->len = 15;
  # line 109 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__7->array, "libffi: unknown", 15);
  # line 109 "../../../../Macaulay2/d/ffi.d"
  str__8 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__8) outofmem2((size_t)sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  # line 109 "../../../../Macaulay2/d/ffi.d"
  str__8->len = 19;
  # line 108 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__8->array, "libffi: bad argtype", 19);
  # line 108 "../../../../Macaulay2/d/ffi.d"
  str__9 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__9) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 108 "../../../../Macaulay2/d/ffi.d"
  str__9->len = 15;
  # line 106 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__9->array, "libffi: bad ABI", 15);
  # line 106 "../../../../Macaulay2/d/ffi.d"
  str__10 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__10) outofmem2((size_t)sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  # line 106 "../../../../Macaulay2/d/ffi.d"
  str__10->len = 19;
  # line 104 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__10->array, "libffi: bad typedef", 19);
  # line 104 "../../../../Macaulay2/d/ffi.d"
  str__11 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__11) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 104 "../../../../Macaulay2/d/ffi.d"
  str__11->len = 6;
  # line 129 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__11->array, "a list", 6);
  # line 129 "../../../../Macaulay2/d/ffi.d"
  str__12 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__12) outofmem2((size_t)sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  # line 129 "../../../../Macaulay2/d/ffi.d"
  str__12->len = 10;
  # line 132 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__12->array, "ffiPrepCif", 10);
  # line 132 "../../../../Macaulay2/d/ffi.d"
  str__13 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__13) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 132 "../../../../Macaulay2/d/ffi.d"
  str__13->len = 6;
  # line 154 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__13->array, "a list", 6);
  # line 154 "../../../../Macaulay2/d/ffi.d"
  str__14 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__14) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 154 "../../../../Macaulay2/d/ffi.d"
  str__14->len = 13;
  # line 158 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__14->array, "ffiPrepCifVar", 13);
  # line 158 "../../../../Macaulay2/d/ffi.d"
  str__15 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__15) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 158 "../../../../Macaulay2/d/ffi.d"
  str__15->len = 6;
  # line 194 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__15->array, "a list", 6);
  # line 194 "../../../../Macaulay2/d/ffi.d"
  str__16 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__16) outofmem2((size_t)sizeof(struct M2_string_struct) + (7)*sizeof(signed char)-sizeof(signed char));
  # line 194 "../../../../Macaulay2/d/ffi.d"
  str__16->len = 7;
  # line 199 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__16->array, "ffiCall", 7);
  # line 199 "../../../../Macaulay2/d/ffi.d"
  str__17 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__17) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 199 "../../../../Macaulay2/d/ffi.d"
  str__17->len = 11;
  # line 204 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__17->array, "ffiVoidType", 11);
  # line 204 "../../../../Macaulay2/d/ffi.d"
  str__18 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__18) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 204 "../../../../Macaulay2/d/ffi.d"
  str__18->len = 30;
  # line 245 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__18->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 245 "../../../../Macaulay2/d/ffi.d"
  str__19 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__19) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 245 "../../../../Macaulay2/d/ffi.d"
  str__19->len = 30;
  # line 235 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__19->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 235 "../../../../Macaulay2/d/ffi.d"
  str__20 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__20) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 235 "../../../../Macaulay2/d/ffi.d"
  str__20->len = 14;
  # line 251 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__20->array, "ffiIntegerType", 14);
  # line 251 "../../../../Macaulay2/d/ffi.d"
  str__21 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__21) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 251 "../../../../Macaulay2/d/ffi.d"
  str__21->len = 30;
  # line 309 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__21->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 309 "../../../../Macaulay2/d/ffi.d"
  str__22 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__22) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 309 "../../../../Macaulay2/d/ffi.d"
  str__22->len = 30;
  # line 293 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__22->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 293 "../../../../Macaulay2/d/ffi.d"
  str__23 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__23) outofmem2((size_t)sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  # line 293 "../../../../Macaulay2/d/ffi.d"
  str__23->len = 17;
  # line 316 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__23->array, "ffiIntegerAddress", 17);
  # line 316 "../../../../Macaulay2/d/ffi.d"
  str__24 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__24) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 316 "../../../../Macaulay2/d/ffi.d"
  str__24->len = 30;
  # line 358 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__24->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 358 "../../../../Macaulay2/d/ffi.d"
  str__25 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__25) outofmem2((size_t)sizeof(struct M2_string_struct) + (30)*sizeof(signed char)-sizeof(signed char));
  # line 358 "../../../../Macaulay2/d/ffi.d"
  str__25->len = 30;
  # line 347 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__25->array, "expected 8, 16, 32, or 64 bits", 30);
  # line 347 "../../../../Macaulay2/d/ffi.d"
  str__26 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__26) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 347 "../../../../Macaulay2/d/ffi.d"
  str__26->len = 15;
  # line 364 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__26->array, "ffiIntegerValue", 15);
  # line 364 "../../../../Macaulay2/d/ffi.d"
  str__27 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__27) outofmem2((size_t)sizeof(struct M2_string_struct) + (22)*sizeof(signed char)-sizeof(signed char));
  # line 364 "../../../../Macaulay2/d/ffi.d"
  str__27->len = 22;
  # line 380 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__27->array, "expected 32 or 64 bits", 22);
  # line 380 "../../../../Macaulay2/d/ffi.d"
  str__28 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__28) outofmem2((size_t)sizeof(struct M2_string_struct) + (11)*sizeof(signed char)-sizeof(signed char));
  # line 380 "../../../../Macaulay2/d/ffi.d"
  str__28->len = 11;
  # line 382 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__28->array, "ffiRealType", 11);
  # line 382 "../../../../Macaulay2/d/ffi.d"
  str__29 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (21)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__29) outofmem2((size_t)sizeof(struct M2_string_struct) + (21)*sizeof(signed char)-sizeof(signed char));
  # line 382 "../../../../Macaulay2/d/ffi.d"
  str__29->len = 21;
  # line 419 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__29->array, "expected 0, 32, or 64", 21);
  # line 419 "../../../../Macaulay2/d/ffi.d"
  str__30 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__30) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 419 "../../../../Macaulay2/d/ffi.d"
  str__30->len = 14;
  # line 424 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__30->array, "ffiRealAddress", 14);
  # line 424 "../../../../Macaulay2/d/ffi.d"
  str__31 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (21)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__31) outofmem2((size_t)sizeof(struct M2_string_struct) + (21)*sizeof(signed char)-sizeof(signed char));
  # line 424 "../../../../Macaulay2/d/ffi.d"
  str__31->len = 21;
  # line 446 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__31->array, "expected 0, 32, or 64", 21);
  # line 446 "../../../../Macaulay2/d/ffi.d"
  str__32 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__32) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 446 "../../../../Macaulay2/d/ffi.d"
  str__32->len = 12;
  # line 451 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__32->array, "ffiRealValue", 12);
  # line 451 "../../../../Macaulay2/d/ffi.d"
  str__33 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__33) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 451 "../../../../Macaulay2/d/ffi.d"
  str__33->len = 14;
  # line 457 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__33->array, "ffiPointerType", 14);
  # line 457 "../../../../Macaulay2/d/ffi.d"
  str__34 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__34) outofmem2((size_t)sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  # line 457 "../../../../Macaulay2/d/ffi.d"
  str__34->len = 27;
  # line 484 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__34->array, "expected a list of pointers", 27);
  # line 484 "../../../../Macaulay2/d/ffi.d"
  str__35 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__35) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 484 "../../../../Macaulay2/d/ffi.d"
  str__35->len = 6;
  # line 488 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__35->array, "a list", 6);
  # line 488 "../../../../Macaulay2/d/ffi.d"
  str__36 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (42)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__36) outofmem2((size_t)sizeof(struct M2_string_struct) + (42)*sizeof(signed char)-sizeof(signed char));
  # line 488 "../../../../Macaulay2/d/ffi.d"
  str__36->len = 42;
  # line 491 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__36->array, "a pointer, string, or a pointer and a list", 42);
  # line 491 "../../../../Macaulay2/d/ffi.d"
  str__37 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__37) outofmem2((size_t)sizeof(struct M2_string_struct) + (17)*sizeof(signed char)-sizeof(signed char));
  # line 491 "../../../../Macaulay2/d/ffi.d"
  str__37->len = 17;
  # line 492 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__37->array, "ffiPointerAddress", 17);
  # line 492 "../../../../Macaulay2/d/ffi.d"
  str__38 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__38) outofmem2((size_t)sizeof(struct M2_string_struct) + (15)*sizeof(signed char)-sizeof(signed char));
  # line 492 "../../../../Macaulay2/d/ffi.d"
  str__38->len = 15;
  # line 498 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__38->array, "ffiPointerValue", 15);
  # line 498 "../../../../Macaulay2/d/ffi.d"
  str__39 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__39) outofmem2((size_t)sizeof(struct M2_string_struct) + (14)*sizeof(signed char)-sizeof(signed char));
  # line 498 "../../../../Macaulay2/d/ffi.d"
  str__39->len = 14;
  # line 504 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__39->array, "ffiStringValue", 14);
  # line 504 "../../../../Macaulay2/d/ffi.d"
  str__40 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__40) outofmem2((size_t)sizeof(struct M2_string_struct) + (27)*sizeof(signed char)-sizeof(signed char));
  # line 504 "../../../../Macaulay2/d/ffi.d"
  str__40->len = 27;
  # line 524 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__40->array, "registerFinalizerForPointer", 27);
  # line 524 "../../../../Macaulay2/d/ffi.d"
  str__41 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__41) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 524 "../../../../Macaulay2/d/ffi.d"
  str__41->len = 6;
  # line 547 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__41->array, "a list", 6);
  # line 547 "../../../../Macaulay2/d/ffi.d"
  str__42 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__42) outofmem2((size_t)sizeof(struct M2_string_struct) + (13)*sizeof(signed char)-sizeof(signed char));
  # line 547 "../../../../Macaulay2/d/ffi.d"
  str__42->len = 13;
  # line 548 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__42->array, "ffiStructType", 13);
  # line 548 "../../../../Macaulay2/d/ffi.d"
  str__43 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__43) outofmem2((size_t)sizeof(struct M2_string_struct) + (19)*sizeof(signed char)-sizeof(signed char));
  # line 548 "../../../../Macaulay2/d/ffi.d"
  str__43->len = 19;
  # line 563 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__43->array, "ffiGetStructOffsets", 19);
  # line 563 "../../../../Macaulay2/d/ffi.d"
  str__44 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__44) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 563 "../../../../Macaulay2/d/ffi.d"
  str__44->len = 6;
  # line 592 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__44->array, "a list", 6);
  # line 592 "../../../../Macaulay2/d/ffi.d"
  str__45 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__45) outofmem2((size_t)sizeof(struct M2_string_struct) + (16)*sizeof(signed char)-sizeof(signed char));
  # line 592 "../../../../Macaulay2/d/ffi.d"
  str__45->len = 16;
  # line 596 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__45->array, "ffiStructAddress", 16);
  # line 596 "../../../../Macaulay2/d/ffi.d"
  str__46 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__46) outofmem2((size_t)sizeof(struct M2_string_struct) + (6)*sizeof(signed char)-sizeof(signed char));
  # line 596 "../../../../Macaulay2/d/ffi.d"
  str__46->len = 6;
  # line 631 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__46->array, "a list", 6);
  # line 631 "../../../../Macaulay2/d/ffi.d"
  str__47 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__47) outofmem2((size_t)sizeof(struct M2_string_struct) + (12)*sizeof(signed char)-sizeof(signed char));
  # line 631 "../../../../Macaulay2/d/ffi.d"
  str__47->len = 12;
  # line 632 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__47->array, "ffiUnionType", 12);
  # line 632 "../../../../Macaulay2/d/ffi.d"
  str__48 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (33)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__48) outofmem2((size_t)sizeof(struct M2_string_struct) + (33)*sizeof(signed char)-sizeof(signed char));
  # line 632 "../../../../Macaulay2/d/ffi.d"
  str__48->len = 33;
  # line 668 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__48->array, "ffi_closure_alloc() returned NULL", 33);
  # line 668 "../../../../Macaulay2/d/ffi.d"
  str__49 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__49) outofmem2((size_t)sizeof(struct M2_string_struct) + (10)*sizeof(signed char)-sizeof(signed char));
  # line 668 "../../../../Macaulay2/d/ffi.d"
  str__49->len = 10;
  # line 679 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__49->array, "a function", 10);
  # line 679 "../../../../Macaulay2/d/ffi.d"
  str__50 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (25)*sizeof(signed char)-sizeof(signed char));
  if (0 == str__50) outofmem2((size_t)sizeof(struct M2_string_struct) + (25)*sizeof(signed char)-sizeof(signed char));
  # line 679 "../../../../Macaulay2/d/ffi.d"
  str__50->len = 25;
  # line 681 "../../../../Macaulay2/d/ffi.d"
  memcpy(str__50->array, "ffiFunctionPointerAddress", 25);
  # line 681 "../../../../Macaulay2/d/ffi.d"
  system__prepare();
  # line 681 "../../../../Macaulay2/d/ffi.d"
  common__prepare();
  # line 681 "../../../../Macaulay2/d/ffi.d"
  hashtables__prepare();
  # line 681 "../../../../Macaulay2/d/ffi.d"
  evaluate__prepare();
  # line 51 "../../../../Macaulay2/d/ffi.d"
  common_setupconst(str__2, toExpr_3(((void *)0)));
  # line 55 "../../../../Macaulay2/d/ffi.d"
  pointerSize = sizeof(void *);
  # line 68 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__3, dlopen0);
  # line 91 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__5, dlsym0);
  # line 93 "../../../../Macaulay2/d/ffi.d"
  ffiTypeVoid = &ffi_type_void;
  # line 94 "../../../../Macaulay2/d/ffi.d"
  ffiOk = FFI_OK;
  # line 100 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__6, ffiTypeSize);
  # line 132 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__12, ffiPrepCif);
  # line 158 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__14, ffiPrepCifVar);
  # line 199 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__16, ffiCall);
  # line 204 "../../../../Macaulay2/d/ffi.d"
  common_setupconst(str__17, toExpr_3(&ffi_type_void));
  # line 251 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__20, ffiIntegerType);
  # line 316 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__23, ffiIntegerAddress);
  # line 364 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__26, ffiIntegerValue);
  # line 382 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__28, ffiRealType);
  # line 424 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__30, ffiRealAddress);
  # line 451 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__32, ffiRealValue);
  # line 457 "../../../../Macaulay2/d/ffi.d"
  common_setupconst(str__33, toExpr_3(&ffi_type_pointer));
  # line 492 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__37, ffiPointerAddress);
  # line 498 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__38, ffiPointerValue);
  # line 504 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__39, ffiStringValue);
  # line 524 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__40, registerFinalizerForPointer);
  # line 548 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__42, ffiStructType);
  # line 563 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__43, ffiGetStructOffsets);
  # line 596 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__45, ffiStructAddress);
  # line 632 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__47, ffiUnionType);
  # line 681 "../../../../Macaulay2/d/ffi.d"
  common_setupfun_1(str__50, ffiFunctionPointerAddress);
  # line 681 "../../../../Macaulay2/d/ffi.d"
  this_thread_prepare.func = ffi__thread_prepare;
  # line 681 "../../../../Macaulay2/d/ffi.d"
  this_thread_prepare.next = thread_prepare_list;
  # line 681 "../../../../Macaulay2/d/ffi.d"
  thread_prepare_list = &this_thread_prepare;
  # line 681 "../../../../Macaulay2/d/ffi.d"
  this_final.func = ffi__final;
  # line 681 "../../../../Macaulay2/d/ffi.d"
  this_final.next = final_list;
  # line 681 "../../../../Macaulay2/d/ffi.d"
  final_list = &this_final;
  # line 681 "../../../../Macaulay2/d/ffi.d"
  }
# line 681 "../../../../Macaulay2/d/ffi.d"
static void ffi__thread_prepare(){
  # line 681 "../../../../Macaulay2/d/ffi.d"
  }
# line 681 "../../../../Macaulay2/d/ffi.d"
static void ffi__final(){
  # line 681 "../../../../Macaulay2/d/ffi.d"
  }
